<?php
##############################################################
# FILENAME  : install_rivals.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  USA
##############################################################
define ( 'IN_PHPBB', true );
$phpbb_root_path	= './';
include ( $phpbb_root_path . 'extension.inc' );
include ( $phpbb_root_path . 'common.'.$phpEx );

$userdata	= session_pagestart ( $user_ip, PAGE_INDEX );
init_userprefs ( $userdata );

$page_title	= 'phpBB Rivals Installation';
include ( $phpbb_root_path . 'includes/page_header.'.$phpEx );

if ( $userdata[ 'user_level' ] != ADMIN )
{
	message_die ( GENERAL_MESSAGE, 'Only administrators and moderators may install this modification.' );
}

$sql		= array ( );
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "clans`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "challenges`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "ladders`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "platforms`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "rivalsconfig`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "tournaments`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "rivalsconfig`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "sponsors`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "modules`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "invites`;";
$sql[ ]	= "DROP TABLE IF EXISTS `" . $table_prefix . "treports`;";
$sql[ ]	= "ALTER TABLE `" . $table_prefix . "users` DROP `user_stats`;";
$sql[ ]	= "ALTER TABLE `" . $table_prefix . "users` DROP `clan_session`;";
$sql[ ]	= "ALTER TABLE `" . $table_prefix . "users` ADD `user_stats` INT( 1 ) NOT NULL;";
$sql[ ]	= "ALTER TABLE `" . $table_prefix . "users` ADD `clan_session` INT( 1 ) NOT NULL ;";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "clans` (
  `clan_id` int(1) NOT NULL auto_increment,
  `clan_name` varchar(25) NOT NULL,
  `clan_tag` varchar(5) NOT NULL,
  `clan_tournaments` text NOT NULL,
  `clan_contact` text NOT NULL,
  `clan_issues` int(1) NOT NULL,
  `clan_members` text NOT NULL,
  `clan_logo` varchar(50) NOT NULL,
  `clan_wrounds` int(1) NOT NULL,
  `clan_lrounds` int(1) NOT NULL,
  `clan_win` int(1) NOT NULL default '0',
  `clan_loss` int(1) NOT NULL default '0',
  `clan_ties` int(1) NOT NULL default '0',
  `clan_ratio` text NOT NULL,
  `clan_owner` int(1) NOT NULL default '0',
  `clan_ownerb` int(1) NOT NULL default '0',
  `ladder_joined` int(1) NOT NULL default '0',
  `clan_score` int(1) NOT NULL default '0',
  `clan_streak` int(1) NOT NULL default '0',
  PRIMARY KEY  (`clan_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "challenges` (
  `challenge_id` int(1) NOT NULL auto_increment,
  `challenger` int(1) NOT NULL,
  `challengee` int(1) NOT NULL,
  `challenge_status` int(1) NOT NULL,
  `challenge_time` text NOT NULL,
  `challenge_extra` text NOT NULL,
  `challenge_rounds` int(1) NOT NULL,
  `c_rounds` text NOT NULL,
  `c_wrounds` text NOT NULL,
  `c_lrounds` text NOT NULL,
  `ce_wrounds` text NOT NULL,
  `ce_lrounds` text NOT NULL,
  `ce_rounds` text NOT NULL,
  `challenge_tie` int(1) NOT NULL,
  `challenge_winner` int(1) NOT NULL,
  `challenge_looser` int(1) NOT NULL,
  PRIMARY KEY  (`challenge_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "ladders` (
  `ladder_id` int(1) NOT NULL auto_increment,
  `ladder_name` varchar(25) NOT NULL,
  `ladder_scoring` int(1) NOT NULL default '0',
  `ladder_issueslt` int(1) NOT NULL,
  `ladder_desc` text NOT NULL,
  `ladder_rank` int(1) NOT NULL default '0',
  `ladder_rules` text NOT NULL,
  `ladder_issues` int(1) NOT NULL,
  `ladder_f1` varchar(25) NOT NULL,
  `ladder_f2` varchar(25) NOT NULL,
  `ladder_rating` int(1) NOT NULL,
  `ladder_order` text NOT NULL,
  `subladder_order` text NOT NULL,
  `ladder_parent` int(1) NOT NULL default '0',
  `platform` int(1) NOT NULL default '0',
  PRIMARY KEY  (`ladder_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "platforms` (
  `platform_id` int(1) NOT NULL auto_increment,
  `platform_name` text NOT NULL,
  PRIMARY KEY  (`platform_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "rivalsconfig` (
  `ticket_recivers` text NOT NULL,
  `ticket_one` int(1) NOT NULL default '0'
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "tournaments` (
  `tournament_id` int(1) NOT NULL auto_increment,
  `tournament_name` varchar(25) NOT NULL,
  `tournament_brackets` text NOT NULL,
  `tournament_status` int(1) NOT NULL,
  `tournament_type` int(1) NOT NULL,
  `tournament_rm` int(1) NOT NULL,
  `tournament_dbllw` int(1) NOT NULL,
  `tournament_dblww` int(1) NOT NULL,
  `tournament_clans2` text NOT NULL,
  `tournament_state` int(1) NOT NULL,
  `tournament_password` text NOT NULL,
  `tournament_clans` text NOT NULL,
  `tournament_winner` int(1) NOT NULL,
  `tournament_info` text NOT NULL,
  `tournament_direction` int(1) NOT NULL,
  PRIMARY KEY  (`tournament_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "sponsors` (
  `sponsor_id` int(1) NOT NULL auto_increment,
  `sponsor_image` varchar(50) NOT NULL,
  `sponsor_desc` text NOT NULL,
  `sponsor_url` varchar(55) NOT NULL,
  `sponsor_tournament` int(1) NOT NULL,
  PRIMARY KEY  (`sponsor_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "modules` (
  `module_id` int(1) NOT NULL auto_increment,
  `module_name` text NOT NULL,
  `module_status` int(1) NOT NULL,
  `module_dep` text NOT NULL,
  PRIMARY KEY  (`module_id`)
);";
$sql[ ]	= "
CREATE TABLE `" . $table_prefix . "treports` (
  `report_id` int(1) NOT NULL auto_increment,
  `report_tournament` int(1) NOT NULL,
  `clan_1` int(1) NOT NULL,
  `clan_2` int(1) NOT NULL,
  `clan_r1` text NOT NULL,
  `clan_r2` text NOT NULL,
  PRIMARY KEY  (`report_id`)
);";
$sql[ ]	= "CREATE TABLE `" . $table_prefix . "invites` (
  `invite_id` int(1) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
  `invite_clan` int(1) NOT NULL ,
  `invite_to` int(1) NOT NULL
) ;";
$sql[ ]	= "INSERT INTO `" . $table_prefix . "rivalsconfig` (
  `ticket_recivers`,
  `ticket_one`) VALUES (
'2',
'0');";
$sql[ ]	= "INSERT INTO `" . $table_prefix . "groups` (
  `group_id`,
  `group_type`,
  `group_name`,
  `group_moderator` ) VALUES (
'NULL',
'0',
'ByPass Words',
'2' );";
$sql[ ]	= "INSERT INTO `" . $table_prefix . "modules` (`module_id`, `module_name`, `module_status`, `module_dep`) VALUES
(1, 'acp', 1, ''),
(2, 'acpaddladder', 1, 'acp|ladder'),
(3, 'acpaddplatform', 1, 'acp|acpaddladder|ladder'),
(4, 'acpaddsubladder', 1, 'acp|acpaddladder|ladder'),
(5, 'acpaddtournament', 1, 'acp|tournaments'),
(6, 'acpconfigure', 1, 'acp'),
(7, 'acpeditbrackets', 1, 'acp|tournaments'),
(8, 'acpeditladder', 1, 'acp|ladder'),
(11, 'acpeditsubladder', 1, 'acp|ladder'),
(10, 'acpeditplatforms', 1, 'acp|ladder'),
(12, 'acpedittournament', 1, 'acp|tournaments'),
(13, 'acpsponsors', 1, 'acp|tournaments'),
(13, 'acpreportmatch', 1, 'acp|ladder'),
(14, 'ccp', 1, ''),
(15, 'ccpchallenges', 1, 'ccp|ladder'),
(16, 'ccpclone', 1, 'ccp|ladder'),
(17, 'ccpmembers', 1, 'ccp'),
(18, 'ccpmodify', 1, 'ccp'),
(19, 'ccpticket', 1, 'ccp'),
(20, 'ccptournaments', 1, 'ccp|tournaments'),
(21, 'ladder', 1, ''),
(22, 'laddercreateclan', 1, 'ladder'),
(23, 'ladderviewclan', 1, 'ladder'),
(24, 'mcp', 1, ''),
(25, 'mcpjlclan', 1, 'mcp'),
(26, 'tournaments', 1, ''),
(27, 'tournamentsbrackets', 1, 'tournaments'),
(28, 'tournamentssignup', 1, 'tournaments|ccp'),
(29, 'tournamentssponsors', 1, 'tournaments');";

$i		= 0;
$code		= '
<table class="forumline" width="100%" cellpadding="2" cellspacing="1">
	<tr>
		<th>Installation Complete</th>
		<th colspan="2">Queries</th>
	</tr>
	<tr class="genmed">
		<td class="row1" valign="top" rowspan="29" width="50%">
			<b>About phpBB Rivals</b>
			<p>
				The mission is <b>simple</b>, to provide a <b>free and open source</b> gaming solution for anyone in the world. Using the power of <i>PHP</i>, the backend of a <i>database</i> and the flexability of <i>phpBB</i> ... you can get your own clan website running in no time.
			</p>
			<p>
				This software is <b>open source</b> and released under the <i>GPL</i>. Feel free to use it for personal or commercial use. Make any modifications you want, under the <i>GPL</i> terms. Just refrain from selling, please.
			</p>

 			<b>Functionality and Flexability</b>
			<p>
				This project allows you to expand your website to the sky. It provides a <b>free</b> ladder, clan and tournament system to use. Easy to setup and install with detailed instructions and automatic updates for your convience.
			</p>
			<p>
				The power to control is yours ... modify the look, feel and functionality of this project to a way that suits your site, that is what <i>open source</i> is all about, giving you the power to make your own modifications.
			</p>

			<b>Post-Installation Instructions</b>
			<p>
				If none of the queries have failed, delete this installation file. If you require any further assistance, please visit <a href="http://www.phpbb.com/">phpBB.com Support Forums</a> or <a href="http://www.gotbase.org/">GotBase?</a> for support.</span>
			</p>
		</td>
	</tr>';
foreach ( $sql AS $query )
{
	$i++;
	$color	= ( $i % 2 ) ? 'row1' : 'row2';

	if ( ! ( $result = $db->sql_query ( $query ) ) )
	{
		$error	= $db->sql_error();
		$code	.= '
	<tr class="genmed">
		<td width="100" class="' . $color . '" align="center" valign="middle"><b>#' . $i . '</b></td>
		<td class="' . $color . '"><b><font color="#FF0000">Failed</font></b></td>
	</tr>';
	}
	else
	{
		$code	.= '
	<tr class="genmed">
		<td width="100" class="' . $color . '" align="center" valign="middle"><b>#' . $i . '</b></td>
		<td class="' . $color . '"><b><font color="#00AA00">Successful</font></b></td>
	</tr>';
	}
}

print $code . '</table>';

include ( $phpbb_root_path . 'includes/page_tail.'.$phpEx );

?>
