<?php
##############################################################
# FILENAME  : rivals.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  USA
##############################################################
define ( 'IN_PHPBB', true );
$phpbb_root_path	= './';
include ( $phpbb_root_path . 'extension.inc' );
include ( $phpbb_root_path . 'common.php' );
include ( $phpbb_root_path . 'includes/bbcode.php' );
include ( $phpbb_root_path . 'includes/functions_post.php' );
include ( $phpbb_root_path . 'rivals/classes/clan.php' );
include ( $phpbb_root_path . 'rivals/classes/tournament.php' );
include ( $phpbb_root_path . 'rivals/classes/module_loader.php' );
include ( $phpbb_root_path . 'rivals/classes/ladder.php' );
include ( $phpbb_root_path . 'rivals/functions.php' );

/**
* Set up the DB information
*/
define ( 'CLANS_TABLE', $table_prefix . 'clans' );
define ( 'CHALLENGES_TABLE', $table_prefix . 'challenges' );
define ( 'LADDERS_TABLE', $table_prefix . 'ladders' );
define ( 'PLATFORMS_TABLE', $table_prefix . 'platforms' );
define ( 'RIVALS_CONFIG', $table_prefix . 'rivalsconfig' );
define ( 'TOURNAMENTS_TABLE', $table_prefix . 'tournaments' );
define ( 'SPONSORS_TABLE', $table_prefix . 'sponsors' );
define ( 'INVITES_TABLE', $table_prefix . 'invites' );
define ( 'MODULES_TABLE', $table_prefix . 'modules' );
define ( 'TOURNAMENT_REPORTS', $table_prefix . 'treports' );

/**
* Setup the phpBB user variables.
*/
$userdata	= session_pagestart ( $user_ip, PAGE_INDEX );
init_userprefs ( $userdata );

/**
* Setup the rivals variables.
*/
$http_vars	= http_vars ( );
$clan		= new clan ( );
$tournament	= new tournament ( );
$ladder		= new ladder ( );

/**
* Load the modules.
*/
$sql	= 'SELECT * FROM ' . MODULES_TABLE . ' WHERE module_name = "' . $http_vars[ 'module' ] . '"';
$result	= $db->sql_query ( $sql );
$row	= $db->sql_fetchrow ( $result );

include ( $phpbb_root_path . 'includes/page_header.' . $phpEx );

// Check if we can load the module.
if ( $row[ 'module_status' ] != 0 )
{
	// Yes, load it.
	$mod	= new module_loader ( 'rivals/modules/' );
	$mod->deps ( );
	$mod->load_module ( $http_vars[ 'module' ] );
}
else
{
	// No, tell the user.
	message_die ( GENERAL_ERROR, $lang[ 'miiaufljdb' ] );
}

include ( $phpbb_root_path . 'includes/page_tail.' . $phpEx );
?>
