<?php
##############################################################
# FILENAME  : functions.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  USA
##############################################################
/**
 * From php.net. Sorts arrays by a key.
 */
function sort_by ( $array,  $keyname = null )
{
 	$myarray	= $inarray	= array ( );

	foreach ( $array AS $i => $befree )
	{
		$myarray[ $i ]	= $array[ $i ][ $keyname ];
	}

	asort ( $myarray );

	foreach ( $myarray AS $key => $befree )
	{
		$inarray[ $key ]	= $array[ $key ];
	}

	return array_reverse ( $inarray );
}

/**
 * From php.net. cynagen@gmail.com
 *
 * @param string $start
 * @return array
 */
function ls ( $start = './' )
{
	// Open the directory.
	$dir	= opendir ( $start );
	while ( false !== ( $found = readdir ( $dir ) ) )
	{
		// Add the files, dirs to the array.
		$get_it[ ]	= $found;
	}

	foreach ( $get_it AS $num => $item )
	{
		// Dir ?
		if ( is_dir ( $start . $item ) && $item != '.' && $item != '..' )
		{
			// Yes, start a new array and re-run the function.
			$output[ $item ]	= ls ( $start . $item . '/' );
		}

		// File ?
		if ( is_file ( $start . $item ) )
		{
			// Yes, append it.
			$output[ ]		= $item;
		}
	}

	// Close & Output.
	closedir ( $dir );
	return $output;
}

/**
 * Find a user with wildcards.
 */
function find_user ( )
{
	global	$http_vars;
	global	$template;
	global	$db;
	global	$lang;

	// Replace the * with a SQL LIKE symbol - %
	$user_search	= preg_replace ( '/\*/', '%', $http_vars[ 'user_search' ] );
	$sql	= 'SELECT * FROM ' . USERS_TABLE . ' WHERE username LIKE "' . $user_search . '" AND user_id != "-1"';
	$result	= $db->sql_query ( $sql );

	// Any users ?
	if ( $db->sql_numrows ( $result ) > 0 )
	{
		// Yes. Enable the user block.
		$template->assign_block_vars ( 'block_user', array ( ) );
		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each clan to the template.
			$template->assign_block_vars ( 'block_user.block_users', array (
				'S_USERNAME' => $row[ 'username' ] )
			);
		}
	}
	else
	{
		// No. Let the user know.
		$template->assign_block_vars ( 'block_nouser', array (
			'L_NOUSERS' => $lang[ 'rivals_r31ie' ] )
		);
	}

	// Assign the other variables to the template.
	$template->assign_vars ( array (
		'U_ACTION' => append_sid ( 'rivals.php?module=ccp&mode=find_user' ) )
	);

	$template->set_filenames ( array (
		'body' => 'rivals/find_user.tpl' )
	);
	$template->pparse ( 'body' );
}


/**
 * Find a clan with wildcards.
 */
function find_clan ( )
{
	global	$http_vars;
	global	$template;
	global	$db;
	global	$lang;
	global	$userdata;

	// Replace the * with a SQL LIKE symbol - %
	$clan_search	= preg_replace ( '/\*/', '%', $http_vars[ 'clan_search' ] );
	$sql	= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE clan_name LIKE "' . $clan_search . '" AND clan_owner != ' . $userdata[ 'user_id' ];
	$result	= $db->sql_query ( $sql );

	// Any clans found ?
	if ( $db->sql_numrows ( $result ) > 0 )
	{
		// Yes. Enable the clan block.
		$template->assign_block_vars ( 'block_clan', array ( ) );
		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Get the clan's ladder.
			$sql_2		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $row[ 'ladder_joined' ];
			$result_2	= $db->sql_query ( $sql_2 );
			$row_2		= $db->sql_fetchrow ( $result_2 );
			$sub		= $row_2[ 'ladder_name' ];

			// Get the clan's sub-ladder.
			$sql_3		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $row_2[ 'ladder_parent' ];
			$result_3	= $db->sql_query ( $sql_3 );
			$row_3		= $db->sql_fetchrow ( $result_3 );
			$ladder		= $row_3[ 'ladder_name' ];

			// Get the clan's platform.
			$sql_4		= 'SELECT * FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $row_3[ 'platform' ];
			$result_4	= $db->sql_query ( $sql_4 );
			$row_4		= $db->sql_fetchrow ( $result_4 );
			$platform	= $row_4[ 'platform_name' ];

			// Assign each clan to the template.
			$template->assign_block_vars ( 'block_clan.block_clans', array (
				'S_CLANNAME' => $row[ 'clan_name' ],
				'S_CLANLADDER' => $ladder,
				'S_CLANSUBLADDER' => $sub,
				'S_CLANPLATFORM' => $platform )
			);
		}
	}
	else
	{
		// No. Let the user know.
		$template->assign_block_vars ( 'block_noclans', array (
			'L_NOCLANS' => $lang[ 'rivals_r3pie' ] )
		);
	}

	// Assign the other variables to the template.
	$template->assign_vars ( array (
		'U_ACTION' => append_sid ( 'rivals.php?module=ccp&mode=find_clan' ) )
	);

	$template->set_filenames ( array (
		'body' => 'rivals/find_clan.tpl' )
	);
	$template->pparse ( 'body' );
	exit;
}

/**
 * Antispam by Ramon Fincken. This code checks if user is in the ByPass words group.
 *
 * @param integer $user_id
 * @param integer $group_id
 * @return boolean
 */
function group_check ( $user_id, $group_id )
{
	global $db;

	// Compare and see if the user is in the group.
	$sql	= 'SELECT user_id FROM ' . USER_GROUP_TABLE . ' WHERE user_id = ' . intval ( $user_id ) . ' AND user_pending = 0 AND ((group_id = ' . intval ( $group_id ) . ') )  LIMIT 1';
	if ( ! ( $result = $db->sql_query ( $sql ) ) )
	{
		// Sorry, query error.
		message_die ( GENERAL_ERROR, 'Could not obtain group information for this user', '', __LINE__, __FILE__, $sql );
	}

	$ok	= false;
	while ( $group_data = $db->sql_fetchrow ( $result ) )
	{
		// Alright, he has a row of records.
		$ok	= true;
	}

	// Return the result.
	return $ok;
}

/**
 * Antispam by Ramon Fincken. This code checks if a word has spam status.
 *
 * @param string $word
 * @param string $text
 * @return boolean
 */
function has_spamstatus ( $word, $text )
{
	$spam_status	= false;
	if ( preg_match ( "#\b(" . str_replace ( "\*", ".*?", preg_quote ( $word, '#' ) ) . ")\b#i", $text ) )
	{
		// Preg says it does, lets let the code know.
		$spam_status	= true;
	}

	return $spam_status;
}

/**
 * Antispam by Ramon Fincken. This code checks the whole text and does the proper things for it.
 *
 * @param string $text
 * @param boolean $website
 * @return boolean
 */
function validate_spam ( $text, $website = false )
{
	global	$db;
	global	$userdata;

	// Get the ByPass Word's group ID.
	$sql		= 'SELECT * FROM ' . GROUPS_TABLE . ' WHERE group_name = "ByPass Words"';
	$result		= $db->sql_query ( $sql );
	$row		= $db->sql_fetchrow ( $result );
	$group_id	= $row[ 'group_id' ];

	if ( $website != false )
	{
		// We are working with a website ... find them!
		$regex	= array (
			'#([a-zA-Z0-9][a-zA-Z0-9-]*\.)+(arpa|root|aero|biz|cat|com|coop|edu|gov|info|int|jobs|mil|mobi|museum|name|net|org|pro|travel|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|uk|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)#is'
		);
		$urls	= array ( );

		while ( list ( $key, $value ) = @each ( $regex ) )
		{
			preg_match_all ( $value, $text, $result );
			$urls[ ]	= $result;
		}

		$found	= array ( );
		while ( list ( $key, $value ) = @each ( $urls ) )
		{
			while ( list ( $key_2, $value_2 ) = @each ( $value ) )
			{
				while ( list ( $key_3, $value_3 ) = @each ( $value_2 ) )
				{
					if ( strlen ( $value_3 ) > 3 )
					{
						if ( !in_array ( $value_3, $found ) )
						{
							$found[ ]	= trim ( $value_3 );
						}
					}
				}
			}
		}

		// Check each site for spam.
		foreach ( $found AS $key => $value )
		{
			$handle		= @fopen ( $value, 'rb' );
			$contents	= '';
			while ( !@feof ( $handle ) )
			{
				$contents	.= @fread ( $handle, 8192 );
			}

			@fclose ( $handle );

			if ( strlen ( $contents ) > 10 )
			{
				validate_spam ( $contents );
			}
		}
	}

	$spam_exp	= $lang[ 'rbypass_words' ];

	$sql	= 'SELECT word FROM ' . WORDS_TABLE;
	if ( $result = $db->sql_query ( $sql ) )
	{
		if ( $row = $db->sql_fetchrow ( $result ) )
		{
			if ( has_spamstatus ( $row[ 'word' ], $text ) )
			{
				$db->sql_freeresult ( $result );

				if ( $userdata[ 'user_level' ] == ADMIN || $userdata[ 'user_level' ] == MOD )
				{
					message_die ( GENERAL_ERROR,  '<b>Usage of forbidden word</b><br />' . $spam_exp . '<br /><br />' . $row[ 'word' ] . '<br />' . $text );
				}
				else
				{
					if ( group_check ( $userdata[ 'user_id' ], $group_id ) == false )
					{
						message_die ( GENERAL_ERROR,  '<b>Usage of forbidden word</b><br />' . $spam_exp . '<br /><br />' . $text );
					}
				}
			}
		}
	}

	$db->sql_freeresult ( $result );
	return true;
}

/**
 * From phpBB code. Re-order the ladders
 *
 * @param string $move
 * @param integer $ladder_id
 */
function re_order ( $move, $ladder_id )
{
	global $db;

	if ( $move == 'up' )
	{
		$move	= '-15';
	}
	else
	{
		$move	= '15';
	}

	// Get the ladder information.
	$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $ladder_id;
	$result	= $db->sql_query ( $sql );
	$row	= $db->sql_fetchrow ( $result );

	if ( $row[ 'ladder_parent' ] == '' || $row[ 'ladder_parent' ] == '0' )
	{
		// This is ladder.
		$field	= 'ladder_order';
	}
	else
	{
		// This is a sub-ladder.
		$field	= 'subladder_order';
	}

	// Do the query to move it up or down.
	$sql	= 'UPDATE ' . LADDERS_TABLE . ' SET ' . $field . ' = ' . $field . ' + ' . $move . ' WHERE ladder_id = ' . $ladder_id;
	$result	= $db->sql_query ( $sql );

	$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' ORDER BY ' . $field . ' ASC';
	$result	= $db->sql_query ( $sql );

	$i = 10;
	while ( $row = $db->sql_fetchrow ( $result ) )
	{
		// Fallow suit with the rest.
		$sql	= 'UPDATE ' . LADDERS_TABLE . ' SET ' . $field . ' = ' . $i . ' WHERE ladder_id = ' . $row[ 'ladder_id' ];
		$db->sql_query ( $sql );

		$i	+= 10;
	}
}

/**
 * Search though multidimensional arrays for a key.
 *
 * @param string $need
 * @param string $haystack
 * @param boolean $strick
 * @return boolean
 */
function in_multi_array ( $needle, $haystack, $strict = '' )
{
	if ( $strict )
	{
		foreach ( $haystack AS $item )
		{
			if ( is_array ( $item ) )
			{
				if ( in_multi_array ( $needle, $item, $strict ) )
				{
					return true;
				}
			}
			else
			{
				if ( $needle === $item )
				{
					return true;
				}
			}
		}
	}
	else
	{
		foreach ( $haystack AS $item )
		{
			if (is_array ( $item ) )
			{
				if ( in_multi_array ( $needle, $item, $strict ) )
				{
					return true;
				}
			}
			else
			{
				if ( $needle == $item )
				{
					return true;
				}
			}
		}
	}

	return false;
}

/**
 * Search though multidimensional arrays and only return things unique.
 *
 * @param array $array
 * @return array
 */
function multi_unique ( $array )
{
	foreach ( $array AS $k => $na )
	{
		$new[ $k ]	= serialize ( $na );
	}

	$uniq		= array_unique ( $new );
	foreach ( $uniq AS $k => $ser )
	{
		$new1[ $k ]	= unserialize ( $ser );
	}

	return $new1;
}

/**
 * wGeric's Insert_PM. This sends a PM to users.
 *
 * @param integer $to_id
 * @param string $message
 * @param string $subject
 * @param integer $from_id
 * @param integer $attach_sig
 * @param integer $html_on
 * @param integer $bbcode_on
 * @param integer $smilies_on
 * @return boolean
 */
function insert_pm(
     $to_id,
     $message,
     $subject,
     $from_id,
     $attach_sig = 0,
     $html_on = 0,
     $bbcode_on = 1,
     $smilies_on = 1)
 {
     global $board_config, $db, $emailer, $html_entities_match, $html_entities_replace, $lang, $phpbb_root_path, $phpEx, $unhtml_specialchars_match, $unhtml_specialchars_replace, $user_ip, $userdata;

     include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
     include_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);

     if ( !$from_id )
     {
         $from_id = $userdata['user_id'];
     }

     //get varibles ready
     $to_id = intval($to_id);
     $from_id = intval($from_id);
     $msg_time = time();
     $attach_sig = ($attach_sig == 0) ? 0 : $userdata['user_attachsig'];

     //get to users info
     $sql = "SELECT user_id, user_notify_pm, user_email, user_lang, user_active
             FROM " . USERS_TABLE . "
             WHERE user_id = '$to_id'
             AND user_id <> " . ANONYMOUS;
     if ( !($result = $db->sql_query($sql)) )
     {
         $error = TRUE;
         $error_msg = $lang['No_such_user'];
     }

     $to_userdata = $db->sql_fetchrow($result);

     $privmsg_subject = trim(strip_tags($subject));
     if ( empty($privmsg_subject) )
     {
         $error = TRUE;
         $error_msg .= ( ( !empty($error_msg) ) ? '<br />' : '' ) . $lang['Empty_subject'];
     }

     if ( !empty($message) )
     {
         if ( !$error )
         {
             if ( $bbcode_on )
             {
                 $bbcode_uid = make_bbcode_uid();
             }

             $privmsg_message = prepare_message($message, $html_on, $bbcode_on, $smilies_on, $bbcode_uid);
             $privmsg_message = str_replace('\\\n', '\n', $privmsg_message);

         }
     }
     else
     {
         $error = TRUE;
         $error_msg .= ( ( !empty($error_msg) ) ? '<br />' : '' ) . $lang['Empty_message'];
     }

     //
     // See if recipient is at their inbox limit
     //
     $sql = "SELECT COUNT(privmsgs_id) AS inbox_items, MIN(privmsgs_date) AS oldest_post_time
             FROM " . PRIVMSGS_TABLE . "
             WHERE ( privmsgs_type = " . PRIVMSGS_NEW_MAIL . "
                     OR privmsgs_type = " . PRIVMSGS_READ_MAIL . "
                     OR privmsgs_type = " . PRIVMSGS_UNREAD_MAIL . " )
                 AND privmsgs_to_userid = " . $to_userdata['user_id'];
     if ( !($result = $db->sql_query($sql)) )
     {
         message_die(GENERAL_MESSAGE, $lang['No_such_user']);
     }

     $sql_priority = ( SQL_LAYER == 'mysql' ) ? 'LOW_PRIORITY' : '';

     if ( $inbox_info = $db->sql_fetchrow($result) )
     {
         if ( $inbox_info['inbox_items'] >= $board_config['max_inbox_privmsgs'] )
         {
             $sql = "SELECT privmsgs_id FROM " . PRIVMSGS_TABLE . "
                     WHERE ( privmsgs_type = " . PRIVMSGS_NEW_MAIL . "
                             OR privmsgs_type = " . PRIVMSGS_READ_MAIL . "
                             OR privmsgs_type = " . PRIVMSGS_UNREAD_MAIL . "  )
                         AND privmsgs_date = " . $inbox_info['oldest_post_time'] . "
                         AND privmsgs_to_userid = " . $to_userdata['user_id'];
             if ( !$result = $db->sql_query($sql) )
             {
                 message_die(GENERAL_ERROR, $lang['No_find_oldest_privmsgs'], '', __LINE__, __FILE__, $sql);
             }
             $old_privmsgs_id = $db->sql_fetchrow($result);
             $old_privmsgs_id = $old_privmsgs_id['privmsgs_id'];

             $sql = "DELETE $sql_priority FROM " . PRIVMSGS_TABLE . "
                     WHERE privmsgs_id = $old_privmsgs_id";
             if ( !$db->sql_query($sql) )
             {
                 message_die(GENERAL_ERROR, $lang['No_delete_oldest_privmsgs'].$sql, '', __LINE__, __FILE__, $sql);
             }

             $sql = "DELETE $sql_priority FROM " . PRIVMSGS_TEXT_TABLE . "
                     WHERE privmsgs_text_id = $old_privmsgs_id";
             if ( !$db->sql_query($sql) )
             {
                 message_die(GENERAL_ERROR, $lang['No_delete_oldest_privmsgs_text'], '', __LINE__, __FILE__, $sql);
             }
         }
     }

     $sql_info = "INSERT INTO " . PRIVMSGS_TABLE . " (privmsgs_type, privmsgs_subject, privmsgs_from_userid, privmsgs_to_userid, privmsgs_date, privmsgs_ip, privmsgs_enable_html, privmsgs_enable_bbcode, privmsgs_enable_smilies, privmsgs_attach_sig)
                 VALUES (" . PRIVMSGS_NEW_MAIL . ", '" . str_replace("\'", "''", $privmsg_subject) . "', " . $from_id . ", " . $to_userdata['user_id'] . ", $msg_time, '$user_ip', $html_on, $bbcode_on, $smilies_on, $attach_sig)";

     if ( !($result = $db->sql_query($sql_info, BEGIN_TRANSACTION)) )
     {
         message_die(GENERAL_ERROR, $lang['No_PM_sent_info'], "", __LINE__, __FILE__, $sql_info);
     }

     $privmsg_sent_id = $db->sql_nextid();

     $sql = "INSERT INTO " . PRIVMSGS_TEXT_TABLE . " (privmsgs_text_id, privmsgs_bbcode_uid, privmsgs_text)
             VALUES ($privmsg_sent_id, '" . $bbcode_uid . "', '" . str_replace("\'", "''", $privmsg_message) . "')";

     if ( !$db->sql_query($sql, END_TRANSACTION) )
     {
         message_die(GENERAL_ERROR, $lang['No_PM_sent_text'], "", __LINE__, __FILE__, $sql);
     }

     //
     // Add to the users new pm counter
     //
     $sql = "UPDATE " . USERS_TABLE . "
             SET user_new_privmsg = user_new_privmsg + 1, user_last_privmsg = " . time() . "
             WHERE user_id = " . $to_userdata['user_id'];
     if ( !$status = $db->sql_query($sql) )
     {
         message_die(GENERAL_ERROR, $lang['No_PM_read_status'], '', __LINE__, __FILE__, $sql);
     }

     if ( $to_userdata['user_notify_pm'] && !empty($to_userdata['user_email']) && $to_userdata['user_active'] )
     {
         $script_name = preg_replace('/^\/?(.*?)\/?$/', "\\1", trim($board_config['script_path']));
         $script_name = ( $script_name != '' ) ? $script_name . '/privmsg.'.$phpEx : 'privmsg.'.$phpEx;
         $server_name = trim($board_config['server_name']);
         $server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
         $server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';

         if ( !class_exists('emailer') )
         {
             include($phpbb_root_path . 'includes/emailer.'.$phpEx);
             $emailer = new emailer($board_config['smtp_delivery']);
         }

         $emailer->from($board_config['board_email']);
         $emailer->replyto($board_config['board_email']);

         $emailer->use_template('privmsg_notify', $to_userdata['user_lang']);
         $emailer->email_address($to_userdata['user_email']);
         $emailer->set_subject($lang['Notification_subject']);

         $emailer->assign_vars(array(
             'USERNAME' => $to_username,
             'SITENAME' => $board_config['sitename'],
             'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '',

             'U_INBOX' => $server_protocol . $server_name . $server_port . $script_name . '?folder=inbox')
         );

         $emailer->send();
         $emailer->reset();
     }

     return;

     $msg = $lang['Message_sent'] . '<br /><br />' . sprintf($lang['Click_return_inbox'], '<a href="' . append_sid("privmsg.$phpEx?folder=inbox") . '">', '</a> ') . '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . append_sid("index.$phpEx") . '">', '</a>');

     message_die(GENERAL_MESSAGE, $msg);

}

?>
