<?php
##############################################################
# FILENAME  : mod_acp.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP ACP Class.
 * Shows and loads the modules.
 */
class mod_acp
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acp ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		if ( !empty ( $http_vars[ 'sub_module' ] ) )
		{
			$sql	= 'SELECT * FROM ' . MODULES_TABLE . ' WHERE module_name = "' . $http_vars[ 'sub_module' ] . '"';
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );

			// Check if we can load the module.
			if ( $row[ 'module_status' ] != 0 )
			{
				// Yes, load it.
				$mod			= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'sub_module' ] );
			}
			else
			{
				$mod			= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'module' ] );
			}
		}
		else
		{
			// Get the modules.
			$sql	= 'SELECT * FROM ' . MODULES_TABLE;
			$result	= $db->sql_query ( $sql );

			for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
			{
				$row	= $db->sql_fetchrow ( $result );

				// Is it an ACP module ?
				if ( strstr ( $row[ 'module_name' ], 'acp' ) )
				{
					// Get a simplar style language.
					if ( strstr ( $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ], ' :: ' ) )
					{
						$explode	= explode ( ' :: ', $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ] );
						$mod_lang	= '<a href="' . append_sid ( 'rivals.php?module=acp&sub_module=' . $row[ 'module_name' ] ) . '">' . $explode[ 1 ] . '</a>';
					}
					else
					{
						$mod_lang	= $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ];
					}

					// Assign each module to the template.
					$template->assign_block_vars ( 'block_modules', array (
						'S_TYPE' => ( $row[ 'module_parent' ] == 1 ) ? 'th class="thTop"' : 'td class="row1"',
						'S_TYPE2' => ( $row[ 'module_parent' ] == 1 ) ? 'th' : 'td',
						'S_MODNAME' => $row[ 'module_name' ],
						'L_LANG' => $mod_lang )
					);
				}
				else
				{
					// It is not one, continue.
					continue;
				}
			}

			// Get the number of clans.
			$sql	= 'SELECT * FROM ' . CLANS_TABLE;
			$result	= $db->sql_query ( $sql );
			$clans	= $db->sql_numrows ( $result );

			// Get the number of pending matches.
			$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = 1';
			$result		= $db->sql_query ( $sql );
			$pmatches	= $db->sql_numrows ( $result );

			// Get the number of on-going matches.
			$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = 2';
			$result		= $db->sql_query ( $sql );
			$omatches	= $db->sql_numrows ( $result );

			// Get the number of finished matches.
			$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = 3';
			$result		= $db->sql_query ( $sql );
			$fmatches	= $db->sql_numrows ( $result );

			// Get the number of ladders.
			$sql		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_parent = 0';
			$result		= $db->sql_query ( $sql );
			$ladders	= $db->sql_numrows ( $result );

			// Get the number of sub-ladders.
			$sql		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_parent = 1';
			$result		= $db->sql_query ( $sql );
			$sladders	= $db->sql_numrows ( $result );

			// Assign the other variables to the template
			$template->assign_vars ( array (
				'L_WELCOME' => $lang[ 'rwelcome' ],
				'L_STATISTICS' => $lang[ 'rstats' ],
				'L_CLANS' => $lang[ 'rivals_mo6' ],
				'L_MATCHES' => $lang[ 'matches' ],
				'L_PMATCHES' => $lang[ 'rivals_pend' ],
				'L_OMATCHES' => $lang[ 'rivals_inm' ],
				'L_FMATCHES' => $lang[ 'fchallenges' ],
				'L_LADDERS' => $lang[ 'Ladders' ],
				'L_SLADDERS' => $lang[ 'sladders' ],
				'S_CLANS' => $clans,
				'S_MATCHES' => $matches,
				'S_PMATCHES' => $pmatches,
				'S_OMATCHES' => $omatches,
				'S_FMATCHES' => $fmatches,
				'S_LADDERS' => $ladders,
				'S_SLADDERS' => $sladders )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/mod_acp.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}
}

?>
