<?php
##############################################################
# FILENAME  : mod_acpaddladder.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Add Ladder Class.
 * Allows the admin to add ladders.
 */
class mod_acpaddladder
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpaddladder ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Get the platforms.
		$sql	= 'SELECT * FROM ' . PLATFORMS_TABLE;
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each platform to the template.
			$template->assign_block_vars ( 'block_platforms', array (
				'S_PLATFORMID' => $row[ 'platform_id' ],
				'S_PLATFORMNAME' => $row[ 'platform_name' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpaddladder' ),
			'L_ADDLADDER' => $lang[ 'rivals_addla' ],
			'L_LADDERNAME2' => $lang[ 'rivals_lnop' ],
			'L_LADDERPLATFORM' => $lang[ 'rivals_1989w' ],
			'L_LADDERRULES' => $lang[ 'rivals_1' ],
			'L_EXPLADDLADDNAME' => $lang[ 'EXPLADDLADDNAME' ],
			'L_EXPLADDPLAT' => $lang[ 'EXPLADDPLAT' ],
			'L_EXPLADDLADDRULE' => $lang[ 'EXPLADDLADDRULE' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpaddladder.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Set up the SQL to add the ladder.
		$sql	= 'INSERT INTO ' . LADDERS_TABLE . ' (ladder_id, ladder_name, platform, ladder_rules) VALUES ("NULL", "' . $http_vars[ 'ladder_name' ] . '", "' . $http_vars[ 'platform' ] . '", "' . $http_vars[ 'ladder_rules' ] . '")';
		$db->sql_query ( $sql );

		// Completed, tell them.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tlia' ] );
	}
}

?>
