<?php
##############################################################
# FILENAME  : mod_acpaddplatform.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Add Platform Class.
 * Allows the admin to add platforms.
 */
class mod_acpaddplatform
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpaddplatform ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_ADDPLATFORM' => $lang[ 'ADDPLATFORM' ],
			'L_RIVALS_1990E' => $lang[ 'rivals_1990e' ],
			'L_EXPPLATNAME' => $lang[ 'EXPPLATNAME' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
			'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpaddplatform' ) )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpaddplatform.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Run the query to add the platform.
		$sql	= 'INSERT INTO ' . PLATFORMS_TABLE . ' (platform_id, platform_name) VALUES ("NULL", "' . $http_vars[ 'plat_name' ] . '")';
		$db->sql_query ( $sql );

		// Completed. Let the user know.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_thgg' ] );
	}
}

?>
