<?php
##############################################################
# FILENAME  : mod_acpaddsubladder.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Add Sub-Ladder Class.
 * Allows the admin to add ladders.
 */
class mod_acpaddsubladder
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpaddsubladder ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$lang;
		global	$userdata;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Get the parent ladders.
		$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE (ladder_parent = "" OR ladder_parent = "0")';
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each ladder to the template.
			$template->assign_block_vars ( 'block_ladders', array (
				'S_LADDERNAME' => $row[ 'ladder_name' ],
				'S_LADDERID' => $row[ 'ladder_id' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpaddsubladder' ),
			'L_RIVALS_1MPAS' => $lang[ 'rivals_1mpas' ],
			'L_ADDLADDER' => $lang[ 'rivals_addla' ],
			'L_EXPSUBL' => $lang[ 'EXPSUBL' ],
			'L_EXPSUBLPARE' => $lang[ 'EXPSUBLPARE' ],
			'L_EXPSUBLNAME' => $lang[ 'EXPSUBLNAME' ],
			'L_EXPSUBLSCOR' => $lang[ 'EXPSUBLSCOR' ],
			'L_LADDERNAME2' => $lang[ 'rivals_lnop' ],
			'L_LADDERRULES' => $lang[ 'rivals_1' ],
			'L_EXPSUBLISSU' => $lang[ 'EXPSUBLISSU' ],
			'L_EXPSUBLRAT' => $lang[ 'EXPSUBLRAT' ],
			'L_EXPSUBLRANK' => $lang[ 'EXPSUBLRANK' ],
			'L_EXPSUBLDESC' => $lang[ 'EXPSUBLDESC' ],
			'L_LADDERPARENT' => $lang[ 'rivals_78881' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
			'L_EXPSUBLF1F2' => $lang[ 'EXPSUBLF1F2' ],
			'L_LADDERRANK' => $lang[ 'rivals_4' ],
			'L_LADDERPLATFORM' => $lang[ 'rivals_1989w' ],
			'L_LADDERSCORING' => $lang[ 'rivals_19896' ],
			'L_RAT' => $lang[ 'rivals_widhs' ],
			'L_LADDERF1F2' => $lang[ 'rivals_1z' ],
			'L_ISSUES' => $lang[ 'rivals_dasmo' ],
			'L_DEFAULT' => $lang[ 'rivals_trigu' ],
			'L_ALTERNATE' => $lang[ 'rivals_trign' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpaddsubladder.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Set up the SQL to add the sub-ladder.
		$sql	= 'INSERT INTO ' . LADDERS_TABLE . ' (ladder_id, ladder_name, ladder_desc, ladder_parent, ladder_scoring, ladder_issues, ladder_rank, ladder_f1,  ladder_f2, ladder_rating) VALUES ("NULL", "' . $http_vars[ 'ladder_name' ] . '", "' . $http_vars[ 'ladder_desc' ] . '", "' . $http_vars[ 'ladder_parent' ] . '", "' . $http_vars[ 'scoring' ] . '", "' . $http_vars[ 'issues' ] . '", "' . $http_vars[ 'ladder_rank' ] . '", "' . $http_vars[ 'ladder_f1' ] . '", "' . $http_vars[ 'ladder_f2' ] . '", "' . $http_vars[ 'ladder_rating' ] . '")';
		$db->sql_query ( $sql );

		// Completed, tell them.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tlia' ] );
	}
}

?>
