<?php
##############################################################
# FILENAME  : mod_acpaddtournament.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Add Tournament Class.
 * Allows the admin to add tournaments.
 */
class mod_acpaddtournament
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpaddtournament ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpaddtournament' ),
			'L_TOURNBRACKETS' => $lang[ 'rivals_8980' ],
			'L_EXPTOURNAME' => $lang[ 'EXPTOURNAME' ],
			'L_EXPTOURSTAT' => $lang[ 'EXPTOURSTAT' ],
			'L_EXPTOURPASS' => $lang[ 'EXPTOURPASS' ],
			'L_EXPTOURBRAC' => $lang[ 'EXPTOURBRAC' ],
			'L_EXPTOURREQU' => $lang[ 'EXPTOURREQU' ],
			'L_EXPTOURINFO' => $lang[ 'EXPTOURINFO' ],
			'L_EXPTOURTYPE' => $lang[ 'EXPTOURTYPE' ],
			'L_EXPTOURDIR' => $lang[ 'EXPTOURDIR' ],
			'L_TOURNSFL' => $lang[ 'TOURNSFL' ],
			'L_TOURNSFR' => $lang[ 'TOURNSFR' ],
			'L_TOURNDIR' => $lang[ 'TOURNDIR' ],
			'L_TOURNTYPE' => $lang[ 'rivals_tmo3' ],
			'L_TOURNSTATE' => $lang[ 'rivals_9999' ],
			'L_TOURNINFO' => $lang[ 'rivals_555' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
			'L_TOURNPASS' => $lang[ 'rivals_1111' ],
			'L_TOURNNAME' => $lang[ 'rivals_3877' ],
			'L_TOURNRM' => $lang[ 'rivals_38xx' ],
			'L_TOURNAMENTS' => $lang[ 'rivals_swiz' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpaddtournament.tpl' )
		);

		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Run the query to add the tournament.
		$sql	= 'INSERT INTO ' . TOURNAMENTS_TABLE . '(`tournament_id`,`tournament_status`,`tournament_name`,`tournament_brackets`,`tournament_state`,`tournament_password`,`tournament_info`,`tournament_type`,`tournament_rm`,`tournament_direction`) VALUES ("NULL","1","' . $http_vars[ 'tourn_name' ] . '","' . $http_vars[ 'brackets' ] . '","' . $http_vars[ 'tourn_state' ] . '","' . $http_vars[ 'password' ] . '","' . $http_vars[ 'tourn_info' ] . '","' . $http_vars[ 'tourn_type' ] . '","' . $http_vars[ 'tourn_rm' ] . '","' . $http_vars[ 'tourn_dir' ] . '")';
		$db->sql_query ( $sql );

		// Completed. Let the user know.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_81982' ] );
	}
}

?>
