<?php
##############################################################
# FILENAME  : mod_acpconfigure.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Configure Class.
 * Allows the admin to manage modules and other Rival's options.
 */
class mod_acpconfigure
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpconfigure ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( $http_vars[ 'type' ] );
		}
		else
		{
			// Get the modules.
			$sql	= 'SELECT * FROM ' . MODULES_TABLE;
			$result	= $db->sql_query ( $sql );

			for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
			{
				$row	= $db->sql_fetchrow ( $result );

				// Assign each module to the template.
				$template->assign_block_vars ( 'block_modules', array (
					'S_MODNAME' => $row[ 'module_name' ],
					'L_LANG' => $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ],
					'S_STATUS' => ( $row[ 'module_status' ] == 0 ) ? $lang[ 'disabled' ] : $lang[ 'enabled' ],
					'S_STATUS2' => $row[ 'module_status' ] )
				);
			}

			// Other options.
			$sql		= 'SELECT * FROM ' . RIVALS_CONFIG;
			$result		= $db->sql_query ( $sql );
			$row		= $db->sql_fetchrow ( $result );

			$template->assign_vars ( array (
				'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpconfigure' ),
				'L_CONFIG' => $lang[ 'rivals_edcon' ],
				'L_ONLYONE' => $lang[ 'rivals_edcon2' ],
				'L_RIVALS_1MPA6' => $lang[ 'rivals_1mpa6' ],
				'S_CONFIG' => $row[ 'ticket_recivers' ],
				'L_MODULES' => $lang[ 'rivals_modulem' ],
				'L_EXPCONFTICK' => $lang[ 'EXPCONFTICK' ],
				'L_EXPCONFTICKONE' => $lang[ 'EXPCONFTICKONE' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
				'S_SELECTED' => ( !empty ( $row[ 'ticket_one' ] ) ) ? 'checked="checked"' : '',
				'L_CONFIGONE' => $lang[ 'rivals_edcon1' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/mod_acpconfigure.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param integer $case
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Switch though the cases.
		switch ( $case )
		{
			case 1 :
				// Updating ticket options.
				$sql	= 'UPDATE ' . RIVALS_CONFIG . ' SET ticket_recivers = "' . $http_vars[ 'ticket_r' ] . '", ticket_one = "' . $http_vars[ 'ticket_1' ] . '"';
				$db->sql_query ( $sql );

				// Completed, tell the user.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_trchb' ] );
			break;
			case 2 :
				$explode	= explode ( '|', $http_vars[ '_module' ] );
				$status		= ( $explode[ 1 ] == 1 ) ? 0 : 1;

				// Run the query to change the state.
				$sql	= 'UPDATE ' . MODULES_TABLE . ' SET module_status = ' . $status . ' WHERE module_name = "' . $explode[ 0 ] . '"';
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_thgsg' ] );
		}
	}
}

?>
