<?php
##############################################################
# FILENAME  : mod_acpeditbrackets.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Edit Brackets Class.
 * Allows the admin to edit brackets in tournaments.
 */
class mod_acpeditbrackets
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpeditbrackets ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$tournament;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( $http_vars[ 'type' ] );
		}

		// Generate the admin editable tournament.
		$tournament->generate_tournament ( true );

		$template->set_filenames ( array (
			'body' => 'rivals/acp_editbrackets.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param $case integer
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;
		global	$tournament;

		// Switch though the cases.
		switch ( $case )
		{
			case 1 :
				// Get the report data.
				$sql	= 'SELECT * FROM ' . TOURNAMENT_REPORTS . ' WHERE report_id = ' . $http_vars[ 'report_id' ];
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );

				$winner	= ( $row[ 'clan_r1' ] == 'win' ) ? $row[ 'clan_1' ] : $row[ 'clan_2' ];
				$looser	= ( $row[ 'clan_r1' ] == 'win' ) ? $row[ 'clan_2' ] : $row[ 'clan_1' ];

				// Now to get the last bracket ans position of the clan in the tournament.
				$sql	= 'SELECT * FROM ' . TOURNAMENTS_TABLE . ' WHERE tournament_id = ' . $row[ 'report_tournament' ];
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_query ( $result );

				if ( $row[ 'tournament_type' ] == 2 )
				{
					if ( strstr ( $row[ 'tournament_clans2' ], $winner . ':' ) )
					{
						$explode	= explode ( '|', $row[ 'tournament_clans2' ] );
						foreach ( $explode AS $key => $value )
						{
							$explode_2	= explode ( '|', $row[ 'tournament_clans2' ] );
	}
}

?>
