<?php
##############################################################
# FILENAME  : mod_acpeditladder.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Edit Ladder Class.
 * Allows the admin to edit ladders.
 */
class mod_acpeditladder
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpeditladder ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Moving a ladder position.
		if ( !empty ( $http_vars[ 'move' ] ) )
		{
			re_order ( $http_vars[ 'move' ], $http_vars[ 'ladder_id' ] );
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tliu' ] );
		}

		// Get the parent ladders and order them.
		$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE (ladder_parent = "" OR ladder_parent = "0") ORDER BY ladder_order ASC';
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each ladder to the template.
			$template->assign_block_vars ( 'block_ladders', array (
				'L_RIVALS_LNOP' => $lang[ 'rivals_lnop' ],
				'S_LADDERNAME' => $row[ 'ladder_name' ],
				'S_LADDERID' => $row[ 'ladder_id' ],
				'S_LADDERRULES' => $row[ 'ladder_rules' ],
				'U_MOVEUP' => append_sid ( 'rivals.php?module=acp&sub_moduke=acpeditladder&move=up&ladder_id=' . $row[ 'ladder_id' ] ),
				'U_MOVEDOWN' => append_sid ( 'rivals.php?module=acp&sub_moduke=acpeditladder&move=down&ladder_id=' . $row[ 'ladder_id' ] ),
				'L_RIVALS_1' => $lang[ 'rivals_1' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
				'L_MOVEUP' => $lang[ 'rivals_whocares' ],
				'L_RIVALS_1MWXS' => $lang[ 'rivals_1mwxs' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
				'L_MOVEDOWN' => $lang[ 'rivals_mehpp' ],
				'L_DELETE' => $lang[ 'rivals_wyuc' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_RIVALS_1MWXS' => $lang[ 'rivals_1mwxs' ],
			'L_RIVALS_1MPXS' => $lang[ 'rivals_1mpxs' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
			'U_ACTION' => append_sid ( 'rivals.php?action=acp&mode=acpeditladder' ) )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpeditladder.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Are we deleting ?
		if ( !empty ( $http_vars[ 'delete' ] ) )
		{
			// Yes.
			$sql	= 'DELETE FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $http_vars[ 'ladder_id' ];
			$db->sql_query ( $sql );
		}
		else
		{
			// No.
			$sql	= 'UPDATE ' . LADDERS_TABLE . ' SET ladder_name = "' . $http_vars[ 'ladder_name' ] . '", ladder_rules = "' . $http_vars[ 'ladder_rules' ] . '" WHERE ladder_id = ' . $http_vars[ 'ladder_id' ];
			$db->sql_query ( $sql );
		}

		// Completed, tell them.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tliu' ] );
	}
}

?>
