<?php
##############################################################
# FILENAME  : mod_acpeditplatforms.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Edit Platforms Class.
 * Allows the admin to edit platforms.
 */
class mod_acpeditplatforms
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpeditplatforms ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Get the platform data.
		$sql	= 'SELECT * FROM ' . PLATFORMS_TABLE;
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each platform to the template.
			$template->assign_block_vars ( 'block_platforms', array (
				'L_RIVALS_1990e' => $lang[ 'rivals_1990e' ],
				'S_PLATFORMID' => $row[ 'platform_id' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
				'S_PLATFORMNAME' => $row[ 'platform_name' ],
				'L_DELETE' => $lang[ 'rivals_wyuc' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_RIVALS_1QWXS' => $lang[ 'rivals_1qwxs' ],
			'U_EDITPLATFORMS' => append_sid ( 'rivals.php?module=acp&sub_module=acpeditplatforms' ) )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpeditplatforms.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Are we deleting a platform ?
		if ( !empty ( $http_vars[ 'delete' ] ) )
		{
			// Yes, run the query.
			$sql	= 'DELETE FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $http_vars[ 'platform_id' ];
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tpido' ] );
		}
		else
		{
			// Run the query to update the platform data.
			$sql	= 'UPDATE ' . PLATFORMS_TABLE . ' SET platform_name = "' . $http_vars[ 'platform_name' ] . '" WHERE platform_id = ' . $http_vars[ 'platform_id' ];
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_thgp' ] );
		}
	}
}

?>
