<?php
##############################################################
# FILENAME  : mod_acpeditsubladder.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Edit Sub-Ladder Class.
 * Allows the admin to edit sub-ladders.
 */
class mod_acpeditsubladder
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpeditsubladder ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Moving a ladder position.
		if ( !empty ( $http_vars[ 'move' ] ) )
		{
			re_order ( $http_vars[ 'move' ], $http_vars[ 'ladder_id' ] );
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tliu' ] );
		}

		// Get the sub-ladders and order them.
		$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE (ladder_parent != "" OR ladder_parent != "0") ORDER BY subladder_order ASC';
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each sub-ladder to the template.
			$template->assign_block_vars ( 'block_ladders', array (
				'S_LADDERNAME' => $row[ 'ladder_name' ],
				'S_LADDERDESC' => $row[ 'ladder_desc' ],
				'L_SCORING' => $lang[ 'rivals_19896' ],
				'S_SCORING' => ( $row[ 'ladder_scoring' ] == 1 ) ? 'selected' : '',
				'S_LADDERID' => $row[ 'ladder_id' ],
				'L_ISSUESS' => $lang[ 'rivals_dasmo' ],
				'S_LADDERRANK' => $row[ 'ladder_rank' ],
				'L_LADDERRANK' => $lang[ 'rivals_4' ],
				'S_ISSUES' => $row[ 'ladder_issues' ],
				'S_PARENT' => $row[ 'ladder_id' ],
				'S_LADDERF1' => $row[ 'ladder_f1' ],
				'S_LADDERF2' => $row[ 'ladder_f2' ],
				'L_RAT' => $lang[ 'rivals_widhs' ],
				'S_RAT' => $row[ 'ladder_rating' ],
				'L_DEFAULT' => $lang[ 'rivals_trigu' ],
				'L_ALTERNATE' => $lang[ 'rivals_trign' ],
				'U_MOVEUP' => append_sid ( 'rivals.php?module=acp&sub_module=acpeditsubladder&move=up&ladder_id=' . $row[ 'ladder_id' ] ),
				'U_MOVEDOWN' => append_sid ( 'rivals.php?module=acp&sub_module=acpeditsubladder&move=down&ladder_id=' . $row[ 'ladder_id' ] ),
				'L_MOVEUP' => $lang[ 'rivals_whocares' ],
				'L_MOVEDOWN' => $lang[ 'rivals_mehpp' ],
				'L_DELETE' => $lang[ 'rivals_wyuc' ] )
			);
		}

		$template->assign_vars ( array (
			'L_RIVALS_1MWXS' => $lang[ 'rivals_1mwxs' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
			'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpeditsubladder' ) )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpeditsubladder.tpl' )
		);

		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Are we deleting ?
		if ( !empty ( $http_vars[ 'delete' ] ) )
		{
			// Yes.
			$sql	= 'DELETE FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $http_vars[ 'ladder_id' ];
			$db->sql_query ( $sql );
		}
		else
		{
			// No.
			$sql	= 'UPDATE ' . LADDERS_TABLE . ' SET ladder_name = "' . $http_vars[ 'ladder_name' ] . '", ladder_desc = "' . $http_vars[ 'ladder_desc' ] . '", ladder_scoring = "' . $http_vars[ 'scoring' ] . '", ladder_issues = "' . $http_vars[ 'issues' ] . '", ladder_rank = "' . $http_vars[ 'ladder_rank' ] . '", ladder_f1 = "' . $http_vars[ 'ladder_f1' ] . '", ladder_f2 = "' . $http_vars[ 'ladder_f2' ] . '", ladder_rating = "' . $http_vars[ 'ladder_rating' ] . '" WHERE ladder_id = ' . $http_vars[ 'ladder_id' ];
			$db->sql_query ( $sql );
		}

		// Completed, tell them.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tliu' ] );
	}
}

?>
