<?php
##############################################################
# FILENAME  : mod_acpedittournament.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Edit Tournament Class.
 * Allows the admin to edit tournaments.
 */
class mod_acpedittournament
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpedittournament ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Get the tournaments.
		$sql	= 'SELECT * FROM ' . TOURNAMENTS_TABLE;
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each tournament to the template.
			$template->assign_block_vars ( 'block_tournaments', array (
				'L_STATE' => ( $row[ 'tournament_state' ] == '1' ) ? $lang[ 'rivals_publ' ] : $lang[ 'rivals_privs' ],
				'L_READY' => ( count ( explode ( '|', $row[ 'tournament_clans' ] ) ) >= $row[ 'tournament_brackets' ] ) ? $lang[ 'rivals_dan39' ] : $lang[ 'rivals_dan40' ],
				'L_READY2' => $lang[ 'rivals_itfr?' ],
				'L_STARTED' => ( $row[ 'tournament_status' ] == '2' ) ? $lang[ 'rivals_dan39' ] : $lang[ 'rivals_dan40' ],
				'L_STARTED2' => $lang[ 'rivals_clone' ],
				'S_TOURNAMENTID' => $row[ 'tournament_id' ],
				'S_TOURNAMENTNAME' => $row[ 'tournament_name' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_EDITBRACKETS' => $lang[ 'edit_brackets' ],
			'U_EDITBRACKETS' => append_sid ( 'rivals.php?module=acp&sub_module=acpeditbrackets' ),
			'L_RIVALS_1QQXE' => $lang[ 'rivals_1qqxe' ],
			'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpedittournament' ),
			'L_START' => $lang[ 'rivals_stfto' ],
			'L_TOURNAMENTS' => $lang[ 'rivals_swiz' ],
			'L_DELETE' => $lang[ 'rivals_wyuc' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpedittournament.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;
		global	$tournament;

		// Are we deleting ?
		if ( !empty ( $http_vars[ 'delete' ] ) )
		{
			// Yes, delete the tournament.
			$sql	= 'DELETE FROM ' . TOURNAMENTS_TABLE . ' WHERE tournament_id = ' . $http_vars[ 'tournament_id' ];
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tpido' ] );
		}
		else
		{
			// No, start the tournament.
			$clans		= explode ( '|', $tournament->data[ 'tournament_clans' ] );
			shuffle ( $clans );
			$new_clans	= '';
			$i		= 0;

			// Loop though the clans.
			foreach ( $clans AS $key => $clan )
			{
				$i++;
				if ( $i == 1 )
				{
					$new_clans	.= $clan . ':1_' . $i;
				}
				else
				{
					$new_clans	.= '|' . $clan . ':1_' . $i;
				}
			}

			// Run the query to put the clans in their positions.
			$sql	= 'UPDATE ' . TOURNAMENTS_TABLE . ' SET tournament_status = "2", tournament_clans = "' . $new_clans . '" WHERE tournament_id = ' . $tournament->data[ 'tournament_id' ];
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_ymnyt' ] );
		}
	}
}

?>
