<?php
##############################################################
# FILENAME  : mod_acpreportmatch.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Report Match Class.
 * Allows the admin to report matches for clans.
 */
class mod_acpreportmatch
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpreportmatch ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Load the clan data ?
		if ( empty ( $http_vars[ 'ladder_id' ] ) )
		{
			// No, display the "noladderid" block.
			$template->assign_block_vars ( 'block_noladderid', array ( ) );

			// Get parent ladders and order them.
			$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE (ladder_parent = "" OR ladder_parent = "0") ORDER BY ladder_order ASC';
			$result	= $db->sql_query ( $sql );
	
			for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
			{
				$row	= $db->sql_fetchrow ( $result );
	
				// Get the platform for each ladder.
				$sql_2		= 'SELECT * FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $row[ 'platform' ];
				$result_2	= $db->sql_query ( $sql_2 );
				$row_2		= $db->sql_fetchrow ( $result_2 );
	
				// Assign it to the template.
				$template->assign_block_vars ( 'block_noladderid.block_ladders', array (
					'S_LADDERNAME' => $row[ 'ladder_name' ],
					'S_PLATFORM' => $row_2[ 'platform_name' ] )
				);
	
				// Get sub-ladders and order them.
				$sql_3		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_parent = "' . $row[ 'ladder_id' ] . '" ORDER BY subladder_order ASC';
				$result_3	= $db->sql_query ( $sql_3 );
	
				for ( $x = 0; $x < $db->sql_numrows ( $result_3 ); $x++ )
				{
					$row_3	= $db->sql_fetchrow ( $result_3 );

					// Assign them to the template.
					$template->assign_block_vars ( 'block_noladderid.block_ladders.block_subladders', array (
						'S_LADDERNAME' => $row_3[ 'ladder_name' ],
						'S_LADDERID' => $row_3[ 'ladder_id' ] )
					);
				}
			}
	
			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'U_ACTION' => append_sid ( 'rivals.php?module=acp&sub_module=acpreportmatch' ),
				'L_LADDERNAME' => $lang[ 'rivals_lnop' ],
				'L_REPORTEXP' => $lang[ 'ufyeouiwq' ],
				'L_REPORT' => $lang[ 'ufyeouiwq' ],
				'L_SUBMIT2' => '',
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
			);
		}
		else
		{
			// Yes, display the "ladderid" block.
			$template->assign_block_vars ( 'block_ladderid', array ( ) );

			// Get the clans for the ladder_id.
			$sql	= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE ladder_joined = ' . $http_vars[ 'ladder_id' ];
			$result	= $db->sql_query ( $sql );
	
			for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
			{
				$row	= $db->sql_fetchrow ( $result );

				// Assign the clans to the template.
				$template->assign_block_vars ( 'block_ladderid.block_clans', array (
					'S_CLANNAME' => $row[ 'clan_name' ],
					'S_CLANID' => $row[ 'clan_id' ] )
				);
			}

			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'U_ACTION' => append_sid ( 'rivals.php?modules=acp&sub_modules=acpreportmatch' ),
				'L_WINNERC' => $lang[ 'rivals_18c97a' ],
				'L_LOOSERCE' => $lang[ 'rivals_18c9da' ],
				'L_TIE' => $lang[ 'ocmgwhat' ],
				'L_REPORTEXP' => $lang[ 'ufyeouiwq' ],
				'L_REPORT' => $lang[ 'ufyeouiwq' ],
				'L_SUBMIT2' => 'submit',
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
			);
		}

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpreportmatch.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Insert the match into the database.
		$date = date ( 'd.m.y' );
		$sql = 'INSERT INTO ' . CHALLENGES_TABLE . ' (challenge_id, challenge_time, challenge_status, challenge_winner, challenger, challengee) VALUES ("NULL", "' . $date . '", "3", "' . $http_vars[ 'clan_winner' ] . '", "' . $http_vars[ 'clan_winner' ] . '", "' . $http_vars[ 'clan_looser' ] . '")';
		$db->sql_query ( $sql );

		// Is this a tie ?
		if ( !empty ( $http_vars[ 'tie' ] ) )
		{
			// Yes, update the clan's data.
			$sql = 'UPDATE ' . CLANS_TABLE . ' SET clan_win = clan_win + "1", clan_score = clan_score + "2", clan_streak = clan_streak + "1" WHERE clan_id = ' . $http_vars[ 'clan_winner' ];
			$db->sql_query ( $sql );

			$sql = 'UPDATE ' . CLANS_TABLE . ' SET clan_loss = clan_loss + "1", clan_score = clan_score + "0", clan_streak = clan_streak - "1" WHERE clan_id = ' . $http_vars[ 'clan_looser' ];
			$db->sql_query ( $sql );
		}
		else
		{
			// No, this is just a win/loose thing.
			$sql = 'UPDATE ' . CLANS_TABLE . ' SET clan_ties = clan_ties + "1", clan_score = clan_score + "1", clan_streak = clan_streak + "1" WHERE clan_id = ' . $http_vars[ 'clan_winner' ];
			$db->sql_query ( $sql );

			$sql = 'UPDATE ' . CLANS_TABLE . ' SET clan_ties = clan_ties + "1", clan_score = clan_score + "1", clan_streak = clan_streak + "1" WHERE clan_id = ' . $http_vars[ 'clan_looser' ];
			$db->sql_query ( $sql );
		}

		// Completed. Let the user know.
		message_die ( GENERAL_MESSAGE, $lang[ 'kurramufs' ] );
	}
}

?>
