<?php
##############################################################
# FILENAME  : mod_acpsponsors.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Sponsors Class.
 * Allows the admin to add sponsors to tournaments.
 */
class mod_acpsponsors
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_acpsponsors ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// Get the tournament data.
		$sql	= 'SELECT * FROM ' . TOURNAMENTS_TABLE;
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Assign each tournament to the template. 
			$template->assign_block_vars ( 'block_tournaments', array (
				'S_TOURNAMENTID' => $row[ 'tournament_id' ],
				'S_TOURNAMENTNAME' => $row[ 'tournament_name' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'U_ACTION' => append_sid ( 'rivals.php?modeule=acp&sub_module=acpsponsors' ),
			'L_ADDSPONSOR' => $lang[ 'rivals_4hkdn' ],
			'L_SPONSORIMG' => $lang[ 'rivals_4hkdt' ],
			'L_SPONSORURL' => $lang[ 'rivals_4hkdq' ],
			'L_SPONSORDESC' => $lang[ 'rivals_4hkdu' ],
			'L_EXPSPONIMG' => $lang[ 'EXPSPONIMG' ],
			'L_EXPSPONURL' => $lang[ 'EXPSPONURL' ],
			'L_EXPSPONDESC' => $lang[ 'EXPSPONDESC' ],
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
			'L_EXPSPONTOUR' => $lang[ 'EXPSPONTOUR' ],
			'L_SPONSORTOURN' => $lang[ 'rivals_4hkda' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_acpsponsors.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Set up the SQL to add the sponsor.
		$sql	= 'INSERT INTO ' . SPONSORS_TABLE . ' (`sponsor_id`,`sponsor_image`,`sponsor_desc`,`sponsor_tournament`,`sponsor_url`) VALUES ("NULL","' . $http_vars[ 'sponsor_image' ] . '","' . $http_vars[ 'sponsor_desc' ] . '","' . $http_vars[ 'sponsor_tournament' ] . '","' . $http_vars[ 'sponsor_url' ] . '")';
		$db->sql_query ( $sql );

		// Completed, tell them.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_6v1k0' ] );
	}
}

?>
