<?php
##############################################################
# FILENAME  : mod_ccp.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Module Class.
 * Allows users to manage clans.
 */
class mod_ccp
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccp ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$clan;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		if ( !empty ( $http_vars[ 'sub_module' ] ) )
		{
			$sql	= 'SELECT * FROM ' . MODULES_TABLE . ' WHERE module_name = "' . $http_vars[ 'sub_module' ] . '"';
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );

			// Check if we can load the module.
			if ( $row[ 'module_status' ] != 0 )
			{
				// Yes, load it.
				$mod			= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'sub_module' ] );
			}
			else
			{
				$mod			= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'module' ] );
			}
		}
		else
		{
			if ( !empty ( $http_vars[ 'details' ] ) )
			{
				// Get the challenge information.
				$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_id = ' . $http_vars[ 'challenge_id' ];
				$result	= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				if ( empty ( $row[ 'challenge_time' ] ) )
				{
					// No set time, use default.
					$time	= $lang[ 'rivals_nst' ];
				}
				else
				{
					$time	= $row[ 'challenge_time' ];
				}

				// Completed. Show the details of the challenge.
				message_die ( GENERAL_MESSAGE, sprintf ( $lang[ 'rivals_vmds' ], $clan->data ( 'clan_name', $row[ 'challenger' ] ), $time, $row[ 'challenge_extra' ] ) );
			}

			if ( !empty ( $http_vars[ 'switch' ] ) )
			{
				$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE (clan_owner = "' . $userdata[ 'user_id' ] . '" OR clan_ownerb = "' . $userdata[ 'user_id' ] . '") AND clan_id = ' . $http_vars[ 'switch' ];
				$result	= $db->sql_query ( $sql );

				if ( $db->sql_numrows ( $result ) == 0 )
				{
					redirect ( append_sid ( 'rivals.php?module=ccp' ) );
				}

				$sql	= 'UPDATE ' . USERS_TABLE . ' SET clan_session = "' . $http_vars[ 'switch' ] . '" WHERE user_id = ' . $userdata[ 'user_id' ];
				$db->sql_query ( $sql );
				redirect ( append_sid ( 'rivals.php?module=ccp' ) );
			}

			if ( !empty ( $http_vars[ 'mode' ] ) )
			{
				if ( $http_vars[ 'mode' ] == 'find_clan' )
				{
					// Load the function.
					find_clan ( );
				}
				else
				{
					// Load the function.
					find_user ( );
				}
			}

			if ( empty ( $clan->data[ 'clan_id' ] ) )
			{
				if ( !empty ( $http_vars[ 'submit' ] ) )
				{
					// Handle the submitted data.
					$this->handle_submit ( );
				}
				else
				{
					// Check if the user is a clan owner or backup owner.
					$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE (clan_owner = "' . $userdata[ 'user_id' ] . '" OR clan_ownerb = "' . $userdata[ 'user_id' ] . '")';
					$result	= $db->sql_query ( $sql );

					for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
					{
						$row	= $db->sql_fetchrow ( $result );

						// Assign each clan they own to the template.
						$template->assign_block_vars ( 'block_clans', array (
							'S_CLANID' => $row[ 'clan_id' ],
							'S_CLANNAME' => $row[ 'clan_name' ] )
						);
					}

					// Assign the other variables to the template.
					$template->assign_vars ( array (
						'L_SESSION' => $lang[ 'rivals_sess' ],
						'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
					);

					$template->set_filenames ( array (
						'body' => 'rivals/mod_ccp.tpl' )
					);
					$template->pparse ( 'body' );
				}
			}
			else
			{
				// Get a list of the other clans the owner or backup owner own.
				$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE clan_id != "' . $clan->data[ 'clan_id' ] . '" AND (clan_owner = ' . $userdata[ 'user_id' ] . ' OR clan_ownerb = ' . $userdata[ 'user_id' ] . ')';
				$result		= $db->sql_query ( $sql );

				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row_2	= $db->sql_fetchrow ( $result );

					// Get the clan's sub-ladder.
					$sql_3		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $row_2[ 'ladder_joined' ];
					$result_3	= $db->sql_query ( $sql_3 );
					$row_3		= $db->sql_fetchrow ( $result_3 );
					$sub		= $row_3[ 'ladder_name' ];

					// Get the clan's ladder based on the sub-ladder.
					$sql_4		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $row_3[ 'ladder_parent' ];
					$result_4	= $db->sql_query ( $sql_4 );
					$row_4		= $db->sql_fetchrow ( $result_4 );
					$ladder		= $row_4[ 'ladder_name' ];

					// Get the clan's platform based on the ladder.
					$sql_5		= 'SELECT * FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $row_4[ 'platform' ];
					$result_5	= $db->sql_query ( $sql_5 );
					$row_5		= $db->sql_fetchrow ( $result_5 );
					$platform	= $row_5[ 'platform_name' ];

					// Assign each clan to the template.
					$template->assign_block_vars ( 'block_clans', array (
						'S_PLATFORM' => $platform,
						'S_LADDER' => $ladder,
						'S_SUB' => $sub,
						'L_RIVALS_SWITCHTO' => $lang[ 'rivals_switchto' ],
						'S_CLANNAME' => $row_2[ 'clan_name' ],
						'U_CLANNAME' => append_sid ( 'rivals.php?module=ccp&switch=' . $row_2[ 'clan_id' ] ) )
					);
				}

				// I can't even remember what the hell this stuff is for ...
				// I think it's for having a ladder/sub-ladder list.
				$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE (ladder_parent = "" OR ladder_parent = "0") ORDER BY ladder_order ASC';
				$result	= $db->sql_query ( $sql );

				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Get the ladder's platform.
					$sql_2		= 'SELECT * FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $row[ 'platform' ];
					$result_2	= $db->sql_query ( $sql_2 );
					$row_2		= $db->sql_fetchrow ( $result_2 );

					// Assign the ladder to the template.
					$template->assign_block_vars ( 'block_ladders', array (
						'S_LADDERNAME' => $row[ 'ladder_name' ],
						'S_PLATFORM' => $row_2[ 'platform_name' ] )
					);

					// Get the sub-ladders of the ladder.
					$sql_3		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_parent = "' . $row[ 'ladder_id' ] . '" ORDER BY subladder_order ASC';
					$result_3	= $db->sql_query ( $sql_3 );

					for ( $x = 0; $x < $db->sql_numrows ( $result_3 ); $x++ )
					{
						$row_3	= $db->sql_fetchrow ( $result_3 );

						// Assign each sub-ladder to the template.
						$template->assign_block_vars ( 'block_ladders.block_subladders', array (
							'S_LADDERNAME' => $row_3[ 'ladder_name' ],
							'S_LADDERID' => $row_3[ 'ladder_id' ] )
						);
					}
				}

				// Get the clan's sub-ladder.
				$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $clan->data[ 'ladder_joined' ];
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );
				$sub	= $row[ 'ladder_name' ];

				// Get the clan's ladder based on the sub-ladder.
				$sql_2		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_id = ' . $row[ 'ladder_parent' ];
				$result_2	= $db->sql_query ( $sql_2 );
				$row_2		= $db->sql_fetchrow ( $result_2 );
				$ladder		= $row_2[ 'ladder_name' ];

				// Get the clan's platform based on the ladder.
				$sql_3		= 'SELECT * FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $row_2[ 'platform' ];
				$result_3	= $db->sql_query ( $sql_3 );
				$row_3		= $db->sql_fetchrow ( $result_3 );
				$platform	= $row_3[ 'platform_name' ];

				$sql	= 'SELECT * FROM ' . MODULES_TABLE;
				$result	= $db->sql_query ( $sql );

				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Is it an CCP module ?
					if ( strstr ( $row[ 'module_name' ], 'ccp' ) )
					{
						// Get a simplar style language.
						if ( strstr ( $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ], ' :: ' ) )
						{
							$explode	= explode ( ' :: ', $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ] );
							$mod_lang	= '<a href="' . append_sid ( 'rivals.php?module=ccp&sub_module=' . $row[ 'module_name' ] ) . '">' . $explode[ 1 ] . '</a>';
						}
						else
						{
							$mod_lang	= $lang[ 'rivals_' . strtoupper ( $row[ 'module_name' ] ) ];
						}

						// Assign each module to the template.
						$template->assign_block_vars ( 'block_modules', array (
							'S_TYPE' => ( $row[ 'module_parent' ] == 1 ) ? 'th class="thTop"' : 'td class="row1"',
							'S_TYPE2' => ( $row[ 'module_parent' ] == 1 ) ? 'th' : 'td',
							'S_MODNAME' => $row[ 'module_name' ],
							'L_LANG' => $mod_lang )
						);
					}
					else
					{
						// It is not one, continue.
						continue;
					}
				}

				// Get the number of pending matches.
				$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = 1 AND (challenger = ' . $clan->data[ 'clan_id' ] . ' OR challengee = ' . $clan->data[ 'clan_id' ] . ')';
				$result		= $db->sql_query ( $sql );
				$pmatches	= $db->sql_numrows ( $result );

				// Get the number of on-going matches.
				$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = 2 AND (challenger = ' . $clan->data[ 'clan_id' ] . ' OR challengee = ' . $clan->data[ 'clan_id' ] . ')';
				$result		= $db->sql_query ( $sql );
				$omatches	= $db->sql_numrows ( $result );

				// Get the number of finished matches.
				$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = 3 AND (challenger = ' . $clan->data[ 'clan_id' ] . ' OR challengee = ' . $clan->data[ 'clan_id' ] . ')';
				$result		= $db->sql_query ( $sql );
				$fmatches	= $db->sql_numrows ( $result );

				// Assign the other variables to the template.
				$template->assign_vars ( array (
					'L_WELCOME' => sprintf ( $lang[ 'welcomeccp' ], $clan->data[ 'clan_name' ], $platform, $ladder, $sub ),
					'L_STATISTICS' => $lang[ 'rstats' ],
					'L_MATCHES' => $lang[ 'matches' ],
					'L_PMATCHES' => $lang[ 'rivals_pend' ],
					'L_OMATCHES' => $lang[ 'rivals_inm' ],
					'L_FMATCHES' => $lang[ 'fchallenges' ],
					'S_PMATCHES' => $pmatches,
					'S_OMATCHES' => $omatches,
					'S_FMATCHES' => $fmatches,
					'S_LADDER' => $ladder,
					'S_CLANNAME' => $clan->data[ 'clan_name' ],
					'S_SUB' => $sub,
					'S_PLATFORM' => $platform,
					'U_ACTION' => append_sid ( 'rivals.php?module=ccp' ),
					#'L_CLANMANAGEMENT' => $lang[ 'rivals_cmh' ],
					#'L_CLANMANAGEMENTDESC' => $lang[ 'rivals_cmhd' ],
					'L_RIVALS_CURRMANA' => $lang[ 'rivals_currmana' ],
					'U_ACTION2' => append_sid ( 'rivals.php?module=cpp&sub_module=ccpreporttournament' ),
					'U_ACTION3' => append_sid ( 'rivals.php?module=cpp&sub_module=ccpreportmatch' ),
					'L_CLAN' => $lang[ 'rivals_toci' ],
					#'L_RIVALS_CMH' => $lang[ 'rivals_cmh' ],
					#'L_RIVALS_TOURNAMENTS' => $lang[ 'rivals_tournaments' ],
					#'L_RIVALS_CHALLENGES' => $lang[ 'rivals_challenges' ],
					#'L_RIVALS_MEMBERS' => $lang[ 'rivals_members' ],
					#'L_RIVALS_CEM' => $lang[ 'rivals_cem' ],
					#'L_RIVALS_TICKETS' => $lang[ 'rivals_tickets' ],
					'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
				);

				$template->set_filenames ( array (
					'body' => 'rivals/mod_ccpindex.tpl' )
				);
				$template->pparse ( 'body' );
			}
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @return string
	 */
	function handle_submit ( )
	{
		global	$http_vars;
		global	$lang;
		global	$db;
		global	$userdata;

		// Update the session data - login the clan.
		$sql	= 'UPDATE ' . USERS_TABLE . ' SET clan_session = "' . $http_vars[ 'clan_id' ] . '" WHERE user_id = ' . $userdata[ 'user_id' ];
		$db->sql_query ( $sql );

		// Completed. Let the user know.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_login' ] );
	}
}

?>
