<?php
##############################################################
# FILENAME  : mod_ccpchallenges.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Challenges Class.
 * Accept and Declining of Challenges. Making of challenges.
 */
class mod_ccpchallenges
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccpchallenges ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$clan;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( $http_vars[ 'type' ] );
		}
		else
		{
			// Get all the pending challenges.
			$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = "1" AND challengee = ' . $clan->data[ 'clan_id' ];
			$result	= $db->sql_query ( $sql );

			if ( $db->sql_numrows ( $result ) == 0 )
			{
				// No pending challenges.
				$template->assign_block_vars ( 'block_nopend', array (
					'L_NOPEND' => $lang[ 'rivals_npm' ] )
				);
			}
			else
			{
				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Assign each pending challenge to the template.
					$template->assign_block_vars ( 'block_pend', array (
						'S_CHALLENGEID' => $row[ 'challenge_id' ],
						'S_CLANNAME' => $clan->data ( 'clan_name', $row[ 'challenger' ] ),
						'S_CLANNAME2' => $clan->data ( 'clan_name', $row[ 'challengee' ] ) )
					);
				}
			}

			// Get all the on-going challenges.
			$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_status = "2" AND (challengee = "' . $clan->data[ 'clan_id' ] . '" OR challenger = "' . $clan->data[ 'clan_id' ] . '")';
			$result	= $db->sql_query ( $sql );

			if ( $db->sql_numrows ( $result ) == 0 )
			{
				// No on-going challenges.
				$template->assign_block_vars ( 'block_onn', array (
					'L_ONN' => $lang[ 'rivals_nogm' ] )
				);
			}
			else
			{
				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Assign each on-going challenge to the template.
					$template->assign_block_vars ( 'block_on', array (
						'S_CHALLENGEID' => $row[ 'challenge_id' ],
						'S_CLANNAME' => $clan->data ( 'clan_name', $row[ 'challenger' ] ),
						'S_CLANNAME2' => $clan->data ( 'clan_name', $row[ 'challengee' ] ) )
					);
				}
			}

			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'U_QUICK' => append_sid ( 'rivals.php?module=cpp&sub_module=ccpreportmatch&quick=true' ),
				'L_QUICKREPORT' => $lang[ 'rivals_1z9' ],
				'L_FINDCLAN' => $lang[ 'rivals_e32j' ],
				'L_MAKECHALLENGE' => $lang[ 'rivals_mac' ],
				'L_EXTRA' => $lang[ 'rivals_ext' ],
				'L_ACCEPT' => $lang[ 'rivals_atc' ],
				'L_TIE' => $lang[ 'ocmgwhat' ],
				'L_DECLINE' => $lang[ 'rivals_dtc' ],
				'L_ROUNDS' => $lang[ 'rivals_rouns' ],
				'L_PENDING' => $lang[ 'rivals_pend' ],
				'L_CLAN' => $lang[ 'rivals_toci' ],
				'L_DETAILS' => $lang[ 'rivals_vmd' ],
				'L_ONGOING' => $lang[ 'rivals_inm' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
				'L_DETAILS' => $lang[ 'rivals_vmd' ],
				'U_FINDUSER' => append_sid ( 'rivals.php?module=ccp&mode=find_user' ),
				'L_TIME' => $lang[ 'rivals_mt' ],
				'U_FINDCLAN' => append_sid ( 'rivals.php?module=ccp&mode=find_clan' ),
				'L_LOSS' => $lang[ 'rivals_rl' ],
				'L_WIN' => $lang[ 'rivals_rw' ],
				'L_FINDUSER' => $lang[ 'rivals_1x1s' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/mod_ccpchallenges.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param integer $case
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;
		global	$clan;
		global	$userdata;
		global	$ladder;
		global	$tournament;

		// Switch though the cases.
		switch ( $case )
		{
			case 1 :
				// Update the challenge to on-going.
				$sql	= 'UPDATE ' . CHALLENGES_TABLE . ' SET challenge_status = 2 WHERE challenge_id = ' . $http_vars[ 'challenge_id' ];
				$db->sql_query ( $sql );

				// Get the challenge details.
				$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_id = ' . $http_vars[ 'challenge_id' ];
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				// Get the challenger's clan details.
				$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE clan_id = ' . $row[ 'challenger' ];
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				// Send a PM to the challenger's clan leader and to the logged in clan.
				insert_pm ( $row[ 'clan_owner' ], sprintf ( $lang[ 'rivals_cacp' ], $clan->data[ 'clan_name' ] ),  $lang[ 'rivals_cacps' ], $clan->data[ 'clan_owner' ] );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_cdacc' ] );
			break;
			case 2 :
				// Get the challenge details.
				$sql		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE challenge_id = ' . $http_vars[ 'challenge_id' ];
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				// Get the challenger's clan details.
				$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE clan_id = ' . $row[ 'challenger' ];
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				$sql	= 'DELETE FROM ' . CHALLENGES_TABLE . ' WHERE challenge_id = ' . $http_vars[ 'challenge_id' ];
				$db->sql_query ( $sql );

				// Send a PM to the challenger's clan leader and to the logged in clan.
				insert_pm ( $row[ 'clan_owner' ], sprintf ( $lang[ 'rivals_cddem' ], $clan->data[ 'clan_name' ] ),  $lang[ 'rivals_cddes' ], $clan->data[ 'clan_owner' ] );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_cdde' ] );
			break;
			case 3 :
				// Check if user is trying ot challenge self.
				$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE (clan_name = "' . $http_vars[ 'challengee' ] . '" OR clan_id = "' . $http_vars[ 'challengee' ] . '")';
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );
				$challengee	= $row[ 'clan_id' ];

				if ( $challengee == $clan->data[ 'clan_id' ] )
				{
					// They are trying ot challenge self. Warn them.
					message_die ( GENERAL_ERROR, $lang[ 'rivals_uccu' ] );
				}

				// Get all the clan's owned by the user.
				$sql	= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE clan_owner = ' . $userdata[ 'user_id' ];
				$result	= $db->sql_query ( $sql );

				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Check if the user's other clans match,
					// who they are trying to challenge.
					if ( $challengee == $row[ 'clan_id' ] )
					{
						// Match found. Warn them.
						message_die ( GENERAL_ERROR, $lang[ 'rivals_uccu' ] );
					}
				}

				// Limited number of challenge issues if turned on.
				if ( $ladder->data ( 'ladder_issues', $clan->data[ 'ladder_joined' ] ) != 0 )
				{
					// Check if we need to reset the ladder's weekly issues.
					if ( date ( 'd' ) + 7 >= $ladder->data ( 'ladder_issueslt', $clan->data[ 'ladder_joined' ] ) )
					{
						// Reset it for the clan.
						$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_issues = "' . $ladder->data ( 'ladder_issues', $clan->data[ 'ladder_joined' ] ) . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
						$db->sql_query ( $sql );

						// Update the ladder's weekly issues.
						$sql	= 'UPDATE ' . LADDERS_TABLE . ' SET ladder_issueslt = "' . date ( 'd' ) . '" WHERE ladder_id = ' . $clan->data[ 'ladder_joined' ];
						$db->sql_query ( $sql );
					}
				}

				// Limited number of challenge issues if turned on (Second check).
				if ( $ladder->data ( 'ladder_issues', $clan->data[ 'ladder_joined' ] ) != 0 )
				{
					// Has the clan reached their weekly limit ?
					if ( $clan->data[ 'clan_issues' ] == $ladder->data ( 'ladder_issues', $clan->data[ 'ladder_joined' ] ) )
					{
						// Yes. Let the user know.
						message_die ( GENERAL_MESSAGE, $lang[ 'rivals_478' ] );
					}
				}

				// Check their rank on the ladder if turned on.
				if ( $ladder->data ( 'ladder_rank', $clan->data[ 'ladder_joined' ] ) != 0 )
				{
					// Get all the clans in the ladder and order them.
					$sql		= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE ladder_joined = ' . $clan->data[ 'ladder_joined' ] . ' ORDER BY clan_score';
					$result		= $db->sql_query ( $sql );

					// Is the ladder based on clan rating ?
					$rat	= $ladder->data ( 'ladder_rating', $clan->data[ 'ladder_joined' ] );
					if ( !empty ( $rat ) )
					{
						// Yes. Set up the array.
						$data	= array ( );
						for ( $i = 1; $i <= $db->sql_numrows ( $result ); $i++ )
						{
							$row	= $db->sql_fetchrow ( $result );

							// Add each clan and calculate the rating.
							$data[ ]	= array (
								'clan_id' => $row[ 'clan_id' ],
								'clan_name' => $row[ 'clan_name' ],
								'clan_win' => $row[ 'clan_win' ],
								'clan_loss' => $row[ 'clan_loss' ],
								'clan_score' => $row[ 'clan_score' ],
								'clan_streak' => $row[ 'clan_streak' ],
								'clan_rating' => ( $row[ 'clan_win' ] - $row[ 'clan_loss' ] ) + 100
							);
						}

						// Sort the clan by their ratings.
						$new_data	= sort_by ( $data, 'clan_rating' );
						for ( $i = 1; $i <= count ( $new_data ); $i++ )
						{
							if ( $new_data[ 'clan_id' ] == $challengee )
							{
								// Found the challengee. Record the position.
								$position	= $i;
							}
							else if ( $new_data[ 'clan_id' ] == $clan->data[ 'clan_id' ] )
							{
								// Found the challenger. Record the position.
								$position_2	= $i;
							}
							else
							{
								continue;
							}
						}
					}
					else
					{
						// Not based on rating. Search for the clan positions.
						$x			= 0;
						$z			= 0;

						for ( $i = 1; $i <= $db->sql_numrows ( $result ); $i++ )
						{
							$row	= $db->sql_fetchrow ( $result );

							if ( $row[ 'clan_id' ] == $challengee )
							{
								// Found challengee. Record the position.
								$position		= $x;
							}
							else if ( $row[ 'clan_id' ] == $clan->data[ 'clan_id' ] )
							{
								// Found the challenger. Record the position.
								$position_2	= $z;
							}
							else
							{
								$x	+= 1;
								$z	+= 1;
							}
						}
					}

					// Get the position difference.
					if ( $position > $position_2 )
					{
						$position_3	= $position - $position_2;
					}
					else
					{
						$position_3	= $position_2 - $position;
					}

					if ( $position_3 >= $ladder->data ( 'ladder_rank', $clan->data[ 'ladder_joined' ] ) )
					{
						// User can not challenge this clan, they are out of ranking range. Let them know.
						message_die ( GENERAL_MESSAGE, $lang[ 'rivals_3' ] );
					}
				}

				if ( !empty ( $http_vars[ 'time' ] ) )
				{
					// Time is not empty. Compile it from the form array.
					$input_time	= '';
					foreach ( $http_vars[ 'time' ] AS $new_time )
					{
						$input_time	.= $new_time;
					}
				}
				else
				{
					$input_time	= '';
				}

				if ( empty ( $http_vars[ 'rounds' ] ) )
				{
					// Empty rounds. We need at least 3.
					$http_vars[ 'rounds' ]	= 3;
				}

				if ( $ladder->data ( 'ladder_issues', $clan->data[ 'ladder_joined' ] ) != 0 )
				{
					// Update the clan's issues.
					$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_issues = clan_issues + "1" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
					$db->sql_query ( $sql );
				}

				// Finally. Insert the challenge.
				$sql	= 'INSERT INTO ' . CHALLENGES_TABLE . '(challenge_id, challenger, challengee, challenge_status, challenge_extra, challenge_time, challenge_rounds) VALUES ("NULL", "' . $clan->data[ 'clan_id' ] . '", "' . $challengee . '", "1", "' . $http_vars[ 'extra' ] . '", "' . $input_time . '", "' . $http_vars[ 'rounds' ] . '")';
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_chbs' ] );
			break;
		}
	}
}

?>
