<?php
##############################################################
# FILENAME  : mod_ccpclone.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Clone Module Class.
 * Allows clan owners to clone their clan.
 */
class mod_ccpclone
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccpclone ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}

		// I can't even remember what the hell this stuff is for ...
		// I think it's for having a ladder/sub-ladder list.
		$sql	= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE (ladder_parent = "" OR ladder_parent = "0") ORDER BY ladder_order ASC';
		$result	= $db->sql_query ( $sql );

		for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
		{
			$row	= $db->sql_fetchrow ( $result );

			// Get the ladder's platform.
			$sql_2		= 'SELECT * FROM ' . PLATFORMS_TABLE . ' WHERE platform_id = ' . $row[ 'platform' ];
			$result_2	= $db->sql_query ( $sql_2 );
			$row_2		= $db->sql_fetchrow ( $result_2 );

			// Assign the ladder to the template.
			$template->assign_block_vars ( 'block_ladders', array (
				'S_LADDERNAME' => $row[ 'ladder_name' ],
				'S_PLATFORM' => $row_2[ 'platform_name' ] )
			);

			// Get the sub-ladders of the ladder.
			$sql_3		= 'SELECT * FROM ' . LADDERS_TABLE . ' WHERE ladder_parent = "' . $row[ 'ladder_id' ] . '" ORDER BY subladder_order ASC';
			$result_3	= $db->sql_query ( $sql_3 );

			for ( $x = 0; $x < $db->sql_numrows ( $result_3 ); $x++ )
			{
				$row_3	= $db->sql_fetchrow ( $result_3 );

				// Assign each sub-ladder to the template.
				$template->assign_block_vars ( 'block_ladders.block_subladders', array (
					'S_LADDERNAME' => $row_3[ 'ladder_name' ],
					'S_LADDERID' => $row_3[ 'ladder_id' ] )
				);
			}
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_EXPCCPCLON' => $lang[ 'EXPCCPCLON' ],
			'L_CLANCLONE' => $lang[ 'rivals_qia11' ],
			'L_TRANSFER' => $lang[ 'rivals_qia21' ],
			'L_EXPCCPCLON2' => $lang[ 'EXPCCPCLON2' ]
			'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_ccpclone.tpl' )
		);
		$template->pparse ( 'body' );
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param $case interger
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;
		global	$clan;
		global	$userdata;

		// Switch though the cases.
		switch ( $case )
		{
			case 1 :
				// Cloning clan and members.
				$sql	= 'INSERT INTO ' . CLANS_TABLE . ' (clan_id, clan_name, clan_tag, ladder_joined, clan_contact, clan_owner, clan_logo, clan_members) VALUES ("NULL", "' . $clan->data[ 'clan_name' ] . '", "' . $clan->data[ 'clan_tag' ] . '", "' . $http_vars[ 'ladder_id' ] . '", "' . $clan->data[ 'clan_contact' ] . '", "' . $userdata[ 'user_id' ] . '", "' . $clan->data[ 'clan_logo' ] . '", "' . $clan->data[ 'clan_members' ] . '")';
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_qiar1' ] );
			break;
			case 2 :
				// Cloning clan and no members.
				$sql	= 'INSERT INTO ' . CLANS_TABLE . ' (clan_id, clan_name, clan_tag, ladder_joined, clan_contact, clan_owner, clan_logo) VALUES ("NULL", "' . $clan->data[ 'clan_name' ] . '", "' . $clan->data[ 'clan_tag' ] . '", "' . $http_vars[ 'ladder_id' ] . '", "' . $clan->data[ 'clan_contact' ] . '", "' . $userdata[ 'user_id' ] . '", "' . $clan->data[ 'clan_logo' ] . '")';
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_qiar1' ] );
			break;
		}
	}
}

?>
