<?php
##############################################################
# FILENAME  : mod_ccpmembers.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Members Class.
 * Handles clan members.
 */
class mod_ccpmembers
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccpmembers ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( $http_vars[ 'type' ] );
		}
		else
		{
			// Get all the clan members.
			foreach ( explode ( '|', $clan->data[ 'clan_members' ] ) AS $member )
			{
				$sql_2		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $member;
				$result_2	= $db->sql_query ( $sql_2 );
				$row_2		= $db->sql_fetchrow ( $result_2 );

				// Do not include the current user logged into the clan.
				if ( $member != $userdata[ 'user_id' ] )
				{
					// Assign each member to the template.
					$template->assign_block_vars ( 'block_members', array (
						'S_MEMBERID' => $member,
						'S_MEMBERNAME' => $row_2[ 'username' ] )
					);
				}
			}

			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'L_MEMBERMANAGEMENT' => $lang[ 'rivals_mm' ],
				'L_ANL' => $lang[ 'rivals_anlq' ],
				'L_REMOVE' => $lang[ 'rivals_rm' ],
				'L_SANL' => $lang[ 'rivals_sanls' ],
				'L_INVITE' => $lang[ 'rivals_inv' ],
				'L_EXPCCPMEMBINVI' => $lang[ 'EXPCCPMEMBINVI' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/ccpmembers.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param integer $case
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;
		global	$clan;
		global	$userdata;

		// Switch though the cases.
		switch ( $case )
		{
			case 1 :
				// Loop through the clan members. Remove the member from the clan.
				foreach ( explode ( '|', $clan->data[ 'clan_members' ] ) AS $member )
				{
					// Find the member.
					if ( $member == $member_id )
					{
						// Found. Remove the member.
						$new_members	= str_replace ( '|' . $member_id, '', $clan->data[ 'clan_members' ] );
					}
				}

				// Run the query to update the clan's members.
				$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_members = "' . $new_members . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_mdle'  ] );
			break;
			case 2 :
				// Add the current clan owner to the clan members.
				// Remove the selected member out of the clan members.
				// Assign the selected member as the new clan owner.
				$new_members	= $clan->data[ 'clan_members' ] . '|' . $userdata[ 'user_id' ];

				// Run the query to do the changes to the clan.
				$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_members = "' . $new_members . '", clan_owner = "' . $http_vars[ 'member_id' ] . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Remove the session so the previous clan owner can not "hack" in.
				$sql	= 'UPDATE ' . USERS_TABLE . ' SET clan_session = "" WHERE user_id = ' . $userdata[ 'user_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_anl' ] );
			break;
			case 3 :
				// Get the user's information.
				$sql		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE (username = "' . $http_vars[ 'member_id' ] . '" or user_id = "' . $http_vars[ 'member_id' ] . '")';
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				// Insert the invite to the database for pending responce.
				$sql		= 'INSERT INTO ' . INVITES_TABLE . ' (invite_id, invite_clan, invite_to) VALUES ("NULL", "' . $clan->data[ 'clan_id' ] . '", "' . $row[ 'user_id' ] . '")';
				$db->sql_query ( $sql );

				// Send the PM.
				insert_pm ( $row[ 'user_id' ], sprintf ( $lang[ 'rivals_aim' ], $clan->data[ 'clan_name' ], $board_config[ 'server_name' ], $board_config[ 'script_path' ], $clan->data[ 'clan_id' ] ), $lang[ 'rivals_ais' ], $userdata[ 'user_id' ] );

				// Completed. Let the user know.
 				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_ais'  ] );
			break;
			case 4 :
				// Run the query to assign a member as a backup clan owner.
				$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_ownerb = "' . $http_vars[ 'member_id' ] . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_sanl' ] );
			break;
		}
	}
}

?>
