<?php
##############################################################
# FILENAME  : mod_ccpmodify.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Modify Class.
 * Edit/Delete a Clan.
 */
class mod_ccpmodify
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccpmodify ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$clan;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( !empty ( $http_vars[ 'clan_delete' ] ) ? 2 : 1 );
		}
		else
		{
			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'L_DELETE' => $lang[ 'rivals_dtcq' ],
				'L_CLANTAG' => $lang[ 'rivals_ct' ],
				'S_CLANCONTACT' => $clan->data[ 'clan_contact' ],
				'L_CLANCONTACT' => $lang[ 'rivals_cc' ],
				'S_CLANNAME' => $clan->data[ 'clan_name' ],
				'L_CLANNAME' => $lang[ 'rivals_cn' ],
				'S_CLANTAG' => $clan->data[ 'clan_tag' ],
				'L_EXPCCPEDITNAME' => $lang[ 'EXPCCPEDITNAME' ],
				'L_EXPCCPEDITTAG' => $lang[ 'EXPCCPEDITTAG' ],
				'L_EXPCCPEDITLOGO' => $lang[ 'EXPCCPEDITLOGO' ],
				'L_EXPCCPEDITCONT' => $lang[ 'EXPCCPEDITCONT' ],
				'L_CLANEDIT' => $lang[ 'rivals_cem' ],
				'L_CLANLOGO' => $lang[ 'rivals_761' ],
				'S_CLANLOGO' => $clan->data[ 'clan_logo' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/ccpmodify.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param integer $case
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Switch though the cases.
		switch ( $case )
		{
			case 1 :
				// Run the query to update the clan.
				$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_name = "' . $http_vars[ 'clan_name' ] . '", clan_tag = "' . $http_vars[ 'clan_tag' ] . '", clan_contact = "' . $http_vars[ 'clan_contact' ] . '", clan_logo = "' . $http_vars[ 'clan_logo' ] . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_cu'  ] ););
			break;
			case 2 :
				// Run the query to delete the clan.
				$sql	= 'DELETE FROM ' . CLANS_TABLE . ' WHERE clan_id = ' . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_cd'  ] );
			break;
		}
	}
}

?>
