<?php
##############################################################
# FILENAME  : mod_ccpticket.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Ticket Class.
 * Send a ticket.
 */
class mod_ccpticket
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccpticket ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( );
		}
		else
		{
			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'L_TICKET' => $lang[ 'rivals_cnt' ],
				'L_CHEATING' => $lang[ 'rivals_che' ],
				'L_MATCHRESULTS' => $lang[ 'rivals_mrs' ],
				'L_NOSHOW' => $lang[ 'rivals_nosh' ],
				'L_EXPCCPTICK' => $lang[ 'EXPCCPTICK' ],
				'L_OTHER' => $lang[ 'rivals_oths' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/ccptickrt.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param integer $case
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Get the configuration data.
		$sql		= 'SELECT * FROM ' . RIVALS_CONFIG;
		$result		= $db->sql_query ( $sql );
		$row		= $db->sql_fetchrow ( $result );

		// Loop though the ticket recivers.
		foreach ( explode ( '|', $row[ 'ticket_recivers' ] ) AS $reciver )
		{
			// Create a random seed.
			$characters	= 'abcdefghijkmnopqrstuvwxyz023456789';
			srand ( ( double ) microtime ( ) * 1000000 );
			$i		= 0;
			$string		= '';

			while ( $i < 10 )
			{
				$num	= rand ( ) % 33;
				$tmp	= substr ( $characters, $num, 1 );
				$string	.= $tmp;
				$i++;
			}

			// Get an attached file (if any).
			$explode	= explode ( '.', $_FILES[ 'attachment' ][ 'name' ] );
			if ( $row[ 'ticket_one' ] == 1 )
			{
				// Send to only one random ticket reciver.
				if ( !empty ( $_FILES[ 'attachment' ] ) )
				{
					// Upload the attached file.
					$target_path	= $phpbb_root_path . 'uploads/';
					$target_path	= $target_path . $string . '.' . $explode[ 1 ];
					move_uploaded_file ( $_FILES[ 'attachment' ][ 'tmp_name' ], $target_path );
				}

				// Get the reciver and send them the ticket as a PM.
				$sql		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $reciver;
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				insert_pm ( $row[ 'user_id' ], sprintf ( $http_vars[ 'ticket' ] . ' :: %s', $target_path ), $lang[ 'rivals_tick' ] . '(' . $http_vars[ 'type' ] . ')', $userdata[ 'user_id' ] );
				break;
			}
			else
			{
				// Send to all recivers.
				if ( !empty ( $_FILES[ 'attachment' ] ) )
				{
					// Upload the attched file.
					$target_path	= $phpbb_root_path . 'uploads/';
					$target_path	= $target_path . $string . '.' . $explode[ 1 ];
					move_uploaded_file ( $_FILES[ 'attachment' ][ 'tmp_name' ], $target_path );
				}

				// Get the reciver and send them the ticket as a PM.
				$sql		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE username = ' . $reciver;
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );

				insert_pm ( $row[ 'user_id' ], sprintf ( $http_vars[ 'ticket' ] . ' :: %s', $target_path ), $lang[ 'rivals_tick' ], $userdata[ 'user_id' ] );
			}
		}

		// Completed. Let the user know.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_tstr' ] );
	}
}

?>
