<?php
##############################################################
# FILENAME  : mod_ccptournaments.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * CCP Tournaments Class.
 * Allows users to report wins/losses to tournaments.
 */
class mod_ccptournaments
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ccptournaments ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$clan;
		global	$tournament;

		// Are we submitting a form?
		if ( !empty ( $http_vars[ 'submit' ] ) || !empty ( $http_vars[ 'submit_2' ] ) )
		{
			// Yes, load the case based on which form.
			$this->handle_submit ( $http_vars[ 'type' ] );
		}
		else
		{
			if ( empty ( $clan->data[ 'clan_tournaments' ] ) )
			{
				// No tournaments.
				$template->assign_block_vars ( 'block_tn', array (
					'L_NOTOURNY' => $lang[ 'rivals_cowm' ] )
				);
			}
			else
			{
				// Get all the tournaments.
				foreach ( explode ( '|', $clan->data[ 'clan_tournaments' ] ) AS $tournament )
				{
					// Go though each clan in the tournament and get their position.
					$matchup_array	= array ( );
					foreach ( explode ( '|', $tournament->data ( 'tournament_clans', $tournament ) ) AS $clans )
					{
						$stage	= explode ( ':', $clans );
						foreach ( $stage AS $eclan )
						{
							// Get their clan's name.
							$matchup_array[ $stage[ 1 ] ]	= $clan->data ( 'clan_name', $stage[ 0 ] );
						}
					}

					// Test and see if they have a matchup.
					$test	= $this->get_matchup ( $matchup_array, $clan->data[ 'clan_id' ], 1 );
					if ( strlen ( $test ) > 0 || $test == true )
					{
						// They have a matchup.
						$disabled	= '';
					}
					else
					{
						// They do not have a matchup.
						$disabled	= 'disabled';
					}

					$sql_2		= 'SELECT * FROM ' . TOURNAMENTS_TABLE . ' WHERE tournament_id = ' . $tournament;
					$result_2	= $db->sql_query ( $sql_2 );
					$row_2		= $db->sql_fetchrow ( $result_2 );

					// Assign each tournament to the template.
					$template->assign_block_vars ( 'block_t', array (
						'S_TOURNAMENTID' => $row_2[ 'tournament_id' ],
						'S_TOURNAMENTDISABLED' => $disabled,
						'S_TOURNAMENTNAME' => $row_2[ 'tournament_name' ],
						'S_TOURNAMENTTYPE' => ( $row_2[ 'tournament_type' ] == '1' ) ? $lang[ 'rivals_sgvbs' ] : $lang[ 'rivals_7cmqa' ] )
					);
				}
			}

			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'L_TOURNAMENTS' => $lang[ 'rivals_swiz' ],
				'L_DBLELIM' => $lang[ 'rivals_7cmqa' ],
				'L_SINGLEELIM' => $lang[ 'rivals_sgvbs' ],
				'L_LOSSLOSS' => $lang[ 'rivals_7cmqs' ],
				'L_OVERALLWIN' => $lang[ 'rivals_7cmqz' ],
				'L_OVERALLLOSS' => $lang[ 'rivals_7cmqx' ],
				'L_LOSSWIN' => $lang[ 'rivals_7cmqp' ],
				'L_SUBMIT' => $lang[ 'rivals_1x1s' ],
				'L_WHATSTHIS' => $lang[ 'rivals_p1sn2' ],
				'L_WHATSTHIS2' => $lang[ 'rivals_p1dd2' ],
				'L_WIN' => $lang[ 'rivals_rw' ],
				'L_PASSON' => $lang[ 'rivals_p1sn7' ],
				'L_EXPCCPTOUR1' => $lang[ 'EXPCCPTOUR1' ],
				'L_LOSS' => $lang[ 'rivals_rl' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/ccptournaments.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}

	/**
	 * Handles the form data for each case.
	 *
	 * @param integer $case
	 * @return string
	 */
	function handle_submit ( $case )
	{
		global	$http_vars;
		global	$lang;
		global	$db;

		// Switch though the cases.
		switch ( $case )
		{

		}
	}
}

?>
