<?php
##############################################################
# FILENAME  : mod_ladderviewclan.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Ladder View Clan.
 * Shows the clan details and history.
 */
class mod_ladderviewclan
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_ladderviewclan ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$clan;
		global	$images;

		// Get the list of clan members for the clan.
		$i	= 0;
		foreach ( explode ( '|', $clan->data ( 'clan_members', $http_vars[ 'clan_id' ] ) ) AS $member )
		{
			if ( $i == 0 )
			{
				// Get the clan leader.
				$sql_2		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $clan->data ( 'clan_owner', $http_vars[ 'clan_id' ] );
				$result_2	= $db->sql_query ( $sql_2 );
				$row_2		= $db->sql_fetchrow ( $result_2 );

				// Load the profile for the leader.
				$temp_url	= append_sid ( "profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $row_2[ 'user_id' ] );
				$profile_img	= '<a href="' . $temp_url . '"><img src="' . $images[ 'icon_profile' ] . '" alt="' . $lang[ 'Read_profile' ] . '" title="' . $lang[ 'Read_profile' ] . '" border="0" /></a>';
				$temp_url	= append_sid ( "privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $row_2[ 'user_id' ] );
				$pm_img		= '<a href="' . $temp_url . '"><img src="' . $images[ 'icon_pm' ] . '" alt="' . $lang[ 'Send_private_message' ] . '" title="' . $lang[ 'Send_private_message' ] . '" border="0" /></a>';
				$www_img	= ( !empty ( $row_2[ 'user_website' ] ) ) ? '<a href="' . $row_2[ 'user_website' ] . '" target="_userwww"><img src="' . $images[ 'icon_www' ] . '" alt="' . $lang[ 'Visit_website' ] . '" title="' . $lang[ 'Visit_website' ] . '" border="0" /></a>' : 'N/A';
				$aim_img	= ( $row_2[ 'user_aim' ] ) ? '<a href="aim:goim?screenname=' . $row_2[ 'user_aim' ] . '&amp;message=Hello+Are+you+there?"><img src="' . $images[ 'icon_aim' ] . '" alt="' . $lang[ 'AIM' ] . '" title="' . $lang[ 'AIM' ] . '" border="0" /></a>' : 'N/A';
				$msn_img	= ( $row_2[ 'user_msnm' ] ) ? '<a href="' . $temp_url . '"><img src="' . $images[ 'icon_msnm' ] . '" alt="' . $lang[ 'MSNM' ] . '" title="' . $lang[ 'MSNM' ] . '" border="0" /></a>' : 'N/A';
				$yim_img = ( $row_2[ 'user_yim' ] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $row_2[ 'user_yim' ] . '&amp;.src=pg"><img src="' . $images[ 'icon_yim' ] . '" alt="' . $lang[ 'YIM' ] . '" title="' . $lang[ 'YIM' ] . '" border="0" /></a>' : 'N/A';

				// Get the leader's stats from the database.
				$sql_w		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $clan->data ( 'clan_owner', $http_vars[ 'clan_id' ] );
				$result_w	= $db->sql_query ( $sql_w );
				$row_w		= $db->sql_fetchrow ( $result_w );

				$explode_2	= explode ( '|', $row_w[ 'user_stats' ] );
				foreach ( $explode_2 AS $stats )
				{
					$explode_3	= explode ( ':', $stats );
					foreach ( $explode_3 AS $f )
					{
						if ( strstr ( $explode_3[ 0 ], $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) . '(f1)' ) )
						{
							// Custom field #1 stats ...
							$f1	= $explode[ 1 ];
						}
						else if ( strstr ( $explode_3[ 0 ], $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) . '(f2)' ) )
						{
							// Custom field #2 stats ...
							$f2	= $explode[ 1 ];
						}
						else
						{
							continue;
						}
					}
				}

				// Assign the leader's data to the template.
				$template->assign_block_vars ( 'block_memberleader', array (
					'S_MEMBERNAME' => $row_w[ 'username' ],
					'S_MEMBERPROFILE' => $profile_img,
					'S_MEMBERPM' => $pm_img,
					'S_MEMBERWWW' => $www_img,
					'S_MEMBERAIM' => $aim_img,
					'S_MEMBERMSN' => $msn_img,
					'S_MEMBERYIM' => $yim_img,
					'S_MEMBERF1' => ( strlen ( $f1 ) > 0 ) ? $f1 : 0,
					'S_MEMBERF2' => ( strlen ( $f2 ) > 0 ) ? $f2 : 0,
					'S_ROWCOLOR' => 'row2' )
				);
			}

			// Does the clan have members ?
			if ( strlen ( $clan->data ( 'clan_members', $http_vars[ 'clan_id' ] ) ) > 0 )
			{
				// Yes, get them from the database.
				$sql_2		= 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $member;
				$result_2	= $db->sql_query ( $sql_2 );
				$row_2		= $db->sql_fetchrow ( $result_2 );

				// Load each of their profiles.
				$temp_url	= append_sid ( "profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $row_2[ 'user_id' ] );
				$profile_img	= '<a href="' . $temp_url . '"><img src="' . $images[ 'icon_profile' ] . '" alt="' . $lang[ 'Read_profile' ] . '" title="' . $lang[ 'Read_profile' ] . '" border="0" /></a>';
				$temp_url	= append_sid ( "privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $row_2[ 'user_id' ] );
				$pm_img		= '<a href="' . $temp_url . '"><img src="' . $images[ 'icon_pm' ] . '" alt="' . $lang[ 'Send_private_message' ] . '" title="' . $lang[ 'Send_private_message' ] . '" border="0" /></a>';
				$www_img	= ( !empty ( $row_2[ 'user_website' ] ) ) ? '<a href="' . $row_2[ 'user_website' ] . '" target="_userwww"><img src="' . $images[ 'icon_www' ] . '" alt="' . $lang[ 'Visit_website' ] . '" title="' . $lang[ 'Visit_website' ] . '" border="0" /></a>' : 'N/A';
				$aim_img	= ( $row_2[ 'user_aim' ] ) ? '<a href="aim:goim?screenname=' . $row_2[ 'user_aim' ] . '&amp;message=Hello+Are+you+there?"><img src="' . $images[ 'icon_aim' ] . '" alt="' . $lang[ 'AIM' ] . '" title="' . $lang[ 'AIM' ] . '" border="0" /></a>' : 'N/A';
				$msn_img	= ( $row_2[ 'user_msnm' ] ) ? '<a href="' . $temp_url . '"><img src="' . $images[ 'icon_msnm' ] . '" alt="' . $lang[ 'MSNM' ] . '" title="' . $lang[ 'MSNM' ] . '" border="0" /></a>' : 'N/A';
				$yim_img = ( $row_2[ 'user_yim' ] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $row_2[ 'user_yim' ] . '&amp;.src=pg"><img src="' . $images[ 'icon_yim' ] . '" alt="' . $lang[ 'YIM' ] . '" title="' . $lang[ 'YIM' ] . '" border="0" /></a>' : 'N/A';

				// Load each of their stats.
				$explode_2	= explode ( '|', $row_2[ 'user_stats' ] );
				foreach ( $explode_2 AS $stats )
				{
					$explode_3	= explode ( ':', $stats );
					foreach ( $explode_3 AS $f )
					{
						if ( strstr ( $explode_3[ 0 ], $http_vars[ 'clan_id' ] . '(f1)' ) )
						{
							// Custom field #1 stats.
							$f1	= $explode[ 1 ];
						}
						else if ( strstr ( $explode_3[ 0 ], $http_vars[ 'clan_id' ] . '(f2)' ) )
						{
							// Custom field #2 stats.
							$f2	= $explode[ 1 ];
						}
						else
						{
							continue;
						}
					}
				}

				// Assign the member's data to the template.
				$template->assign_block_vars ( 'block_members', array (
					'S_MEMBERNAME' => ( !empty ( $row_2[ 'username' ] ) ) ? $row_2[ 'username' ] : 'N/A',
					'S_MEMBERPROFILE' => $profile_img,
					'S_MEMBERPM' => $pm_img,
					'S_MEMBERWWW' => $www_img,
					'S_CLANTAG' => $clan->data ( 'clan_tag', $http_vars[ 'clan_id' ] ),
					'S_MEMBERAIM' => $aim_img,
					'S_MEMBERMSN' => $msn_img,
					'S_MEMBERYIM' => $yim_img,
					'S_MEMBERF1' => ( strlen ( $f1 ) > 0 ) ? $f1 : 0,
					'S_MEMBERF2' => ( strlen ( $f2 ) > 0 ) ? $f2 : 0,
					'S_ROWCOLOR' => ( $i % 2 ) ? 'row1' : 'row2' )
				);
			}
			else
			{
				// No members, display the "nomembers" block.
				$template->assign_block_vars ( 'block_nomembers', array (
					'L_NOMEMBERS' => $lang[ 'rivals_7887d' ] )
				);
			}

			$i++;
		}

		// Get the pending, on-going and completed matches from the database.
		$sql	= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE (challenger = "' . $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) . '" OR challengee = "' . $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) . '") AND challenge_id = "3" ORDER BY challenge_id DESC';
		$result	= $db->sql_query ( $sql );

		// Did they do any matches ?
		if ( $db->sql_numrows ( $result ) == 0 )
		{
			// No, display the "mhn" block. (mhn = match history no)
			$template->assign_block_vars ( 'block_mhn', array (
				'L_NOMATCHES' => $lang[ 'rivals_aussi' ] )
			);
		}
		else
		{
			// Yes, loop though them.
			for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
			{
				$row_2	= $db->sql_fetchrow ( $result );

				if ( $row_2[ 'challenge_status' ] == '1' )
				{
					// Pending challenge.
					$status	= $lang[ 'rivals_uiiii' ];
				}
				else if ( $row_2[ 'challenge_status' ] == '2' )
				{
					// On-going challenge.
					$status	= $lang[ 'rivals_oiiii' ];
				}
				else
				{
					// Completed challenge.
					$status	= $lang[ 'rivals_tiiii' ];
				}

				// Assign each match to the template.
				$template->assign_block_vars ( 'block_mh', array (
					'S_STATUS' => $status,
					'S_DATE' => ( !empty ( $row_2[ 'challenge_time' ] ) ) ? $row_2[ 'challenge_time' ] : 'N/A',
					'S_CHALLENGER' => ( $row_2[ 'challenger' ] == $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) ) ? '<b>' . $clan->data ( 'clan_name', $row_2[ 'challenger' ] ) . '</b>' : $clan->data ( 'clan_name', $row_2[ 'challenger' ] ),
					'S_CHALLENGEE' => ( $row_2[ 'challengee' ] == $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) ) ? '<b>' . $clan->data ( 'clan_name', $row_2[ 'challengee' ] ) . '</b>' : $clan->data ( 'clan_name', $row_2[ 'challengee' ] ),
					'S_ROWCOLOR' => ( $i++ % 2 ) ? 'row1' : 'row2',
					'S_WINNER' => ( $row_2[ 'challenge_status' ] == '3' ) ? $clan->data ( 'clan_name', $row_2[ 'challenge_winner' ] ) : 'N/A' )
				);
			}
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_RIVALS_CNTI' => $lang[ 'rivals_cnti' ],
			'L_RIVALS_STATISTICS' => $lang[ 'rivals_statistics' ],
			'L_RIVALS_MEMBERS' => $lang[ 'rivals_members' ],
			'L_RIVALS_HISTORY' => $lang[ 'rivals_history' ],
			'L_CLANWINS' => $lang[ 'rivals_wocps' ],
			'L_CLANLOSS' => $lang[ 'rivals_locps' ],
			'L_PM' => $lang[ 'Private_Message' ], 
			'L_WEBSITE' => $lang[ 'Website' ],
			'L_WROUNDS' => $lang[ 'rivals_tivgo' ],
			'L_LROUNDS' => $lang[ 'rivals_tivyo' ],
			'S_CLANLOGO' => $clan->data ( 'clan_logo', $http_vars[ 'clan_id' ] ),
			'L_STREAK' => $lang[ 'rivals_tivlo' ],
			'L_AIM' => $lang[ 'AIM' ],
			'L_YIM' => $lang[ 'YIM' ],
			'L_SCORE' => $lang[ 'rivals_phyyy' ],
			'L_EXTRA' => $lang[ 'rivals_cnti' ],
			'L_MSNM' => $lang[ 'MSNM' ],
			'L_USERNAME' => $lang[ 'Username' ],
			'L_CLANLEADER' => $lang[ 'rivals_fuhr' ],
			'L_CLANMEMBERS' => $lang[ 'rivals_mevc' ],
			'L_CLANTIES' => $lang[ 'clan_ties' ],
			'S_WINS' => ( $clan->data ( 'clan_win', $http_vars[ 'clan_id' ] )  > 0 ) ? $clan->data ( 'clan_win', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_CLANID' => $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ),
			'S_LOSS' => ( $clan->data ( 'clan_loss', $http_vars[ 'clan_id' ] ) > 0 ) ? $clan->data ( 'clan_loss', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_TIES' => ( $clan->data ( 'clan_ties', $http_vars[ 'clan_id' ] ) > 0 ) ? $clan->data ( 'clan_ties', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_WROUNDS' => ( $clan->data ( 'clan_wrounds', $http_vars[ 'clan_id' ] ) > 0 ) ? $clan->data ( 'clan_wrounds', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_LROUNDS' => ( $clan->data ( 'clan_lrounds', $http_vars[ 'clan_id' ] ) > 0 ) ? $clan->data ( 'clan_lrounds', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_STREAK' => ( $clan->data ( 'clan_streak', $http_vars[ 'clan_id' ] ) > 0 ) ? $clan->data ( 'clan_streak', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_SCORE' => ( $clan->data ( 'clan_score', $http_vars[ 'clan_id' ] ) > 0 ) ? $clan->data ( 'clan_score', $http_vars[ 'clan_id' ] ) : 'N/A',
			'S_EXTRA' => ( $clan->data ( 'clan_contact', $http_vars[ 'clan_id' ] ) != null ) ? nl2br ( $clan->data ( 'clan_contact', $http_vars[ 'clan_id' ] ) ) : 'N/A',
			'S_CLANNAME' => $clan->data ( 'clan_name', $http_vars[ 'clan_id' ] ) )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/mod_ladderviewclan.tpl' )
		);
		$template->pparse ( 'body' );
	}
}

?>
