<?php
##############################################################
# FILENAME  : mod_mcp.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Member Control Panel Class.
 * Gives the user a panel showing all their clan's statistics and options.
 */
class mod_mcp
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_mcp ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$clan;

		// Are we loading a sub-module ?
		if ( !empty ( $http_vars[ 'sub_module' ] ) )
		{
			// Yes. Get the sub-module's details from the database.
			$sql	= 'SELECT * FROM ' . MODULES_TABLE . ' WHERE module_name = "' . $http_vars[ 'sub_module' ] . '"';
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );

			// Check if we can load the module.
			if ( $row[ 'module_status' ] != 0 )
			{
				// Yes, load it.
				$mod	= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'sub_module' ] );
			}
			else
			{
				// No, load the default module.
				$mod	= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'module' ] );
			}
		}
		else
		{
			// Get the clans the user is joined in.
			$sql	= 'SELECT * FROM ' . CLANS_TABLE . ' WHERE clan_members != "" AND clan_owner != ' . $userdata[ 'user_id' ];
			$result	= $db->sql_query ( $sql );

			if ( $db->sql_numrows ( $result ) > 0 )
			{
				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Get the clan members. Check if user is in the array.
					$explode	= explode ( '|', $row[ 'clan_members' ] );
					if ( in_array ( $userdata[ 'user_id' ], $explode ) )
					{
						// User is in this clan. Assign the clan to the template.
						$template->assign_block_vars ( 'block_clans', array (
							'S_CLANNAME' => $row[ 'clan_name' ],
							'U_LEAVE' => append_sid ( 'rivals.php?module=mcp&sub_module=mcpjlclan.php&clan_id=' . $row[ 'clan_id' ] ),
							'L_LEAVE' => $lang[ 'rivals_swize' ] )
						);

						// Get the challenges. Pending, on-going and completed.
						$sql_2		= 'SELECT * FROM ' . CHALLENGES_TABLE . ' WHERE (challenger = "' . $row[ 'clan_id' ] . '" OR challengee = "' . $row[ 'clan_id' ] . '") ORDER BY challenge_id DESC';
						$result_2	= $db->sql_query ( $sql_2 );

						if ( $db->sql_numrows ( $result_2 ) > 0 )
						{
							for ( $x = 0; $x < $db->sql_numrows ( $result_2 ); $x++ )
							{
								$row_2	= $db->sql_fetchrow ( $result_2 );

								if ( $row_2[ 'challenge_status' ] == 1 )
								{
									// Pending.
									$status	= $lang[ 'rivals_uiiii' ];
								}
								else if ( $row_2[ 'challenge_status' ] == 2 )
								{
									// On-going.
									$status	= $lang[ 'rivals_oiiii' ];
								}
								else
								{
									// Completed.
									$status	= $lang[ 'rivals_tiiii' ];
								}

								// Assign each match to the template.
								$template->assign_block_vars ( 'block_clans.block_matches', array (
									'S_STATUS' => $status,
									'S_DATE' => ( !empty ( $row_2[ 'challenge_time' ] ) ) ? $row_2[ 'challenge_time' ] : 'N/A',
									'S_CHALLENGER' => ( $row_2[ 'challenger' ] == $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) ) ? '<b>' . $clan->data ( 'clan_name', $row_2[ 'challenger' ] ) . '</b>' : $clan->data ( 'clan_name', $row_2[ 'challenger' ] ),
									'S_CHALLENGEE' => ( $row_2[ 'challengee' ] == $clan->data ( 'clan_id', $http_vars[ 'clan_id' ] ) ) ? '<b>' . $clan->data ( 'clan_name', $row_2[ 'challengee' ] ) . '</b>' : $clan->data ( 'clan_name', $row_2[ 'challengee' ] ),
									'S_ROWCOLOR' => ( $i++ % 2 ) ? 'row1' : 'row2',
									'S_WINNER' => ( $row_2[ 'challenge_status' ] == '3' ) ? $clan->data ( 'clan_name', $row_2[ 'challenge_winner' ] ) : 'N/A' )
								);
							}
						}
						else
						{
							// No matches. Let the user know.
							$template->assign_block_vars ( 'block_clans.block_nomatches', array (
								'L_NOMATCHES' => $lang[ 'rivals_aussi' ] )
							);
						}
					}
				}
			}
			else
			{
				// No clans. Let the user know.
				$template->assign_block_vars ( 'no_clans', array (
					'L_NOCLANS' => $lang[ 'niiacul' ] )
				);
			}

			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'L_RIVALS_MCP' => $lang[ 'mcps' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/mcp.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}
}

?>
