<?php
##############################################################
# FILENAME  : mod_tournaments.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Tournaments Class.
 * Shows and the tournaments and loads the brackets.
 */
class mod_tournaments
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_tournaments ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$tournament;

		// Are we loading a sub-module ?
		if ( !empty ( $http_vars[ 'sub_module' ] ) )
		{
			$sql	= 'SELECT * FROM ' . MODULES_TABLE . ' WHERE module_name = "' . $http_vars[ 'sub_module' ] . '"';
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );

			// Check if we can load the module.
			if ( $row[ 'module_status' ] != 0 )
			{
				// Yes, load it.
				$mod			= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'sub_module' ] );
			}
			else
			{
				$mod			= new module_loader ( 'rivals/modules/' );
				$mod->deps ( );
				$mod->load_module ( $http_vars[ 'module' ] );
			}
		}
		else
		{
			if ( !empty ( $http_vars[ 'tournament_id' ] ) )
			{
				// Check how many spots are free. Not the best method, but it works.
				$math	= $tournament->data[ 'tournament_brackets' ] - count ( explode ( '|', $tournament->data[ 'tournament_clans' ] ) );
				message_die ( GENERAL_MESSAGE, sprintf ( $lang[ 'rivals_wwww' ], ( $math < 0 ) ? 0 : $math, $tournament->data[ 'tournament_info' ] ) );
			}

			// Get all the public tournaments.
			$sql	= 'SELECT * FROM ' . TOURNAMENTS_TABLE . ' WHERE tournament_state != "2"';
			$result	= $db->sql_query ( $sql );

			// Is there any ?
			if ( $db->sql_numrows ( $result ) > 0 )
			{
				// Yes, loop though them.
				for ( $i = 0; $i < $db->sql_numrows ( $result ); $i++ )
				{
					$row	= $db->sql_fetchrow ( $result );

					// Check if there are any sponsors.
					$sql_2		= 'SELECT * FROM ' . SPONSORS_TABLE . ' WHERE sponsor_tournament = ' . $row[ 'tournament_id' ];
					$result_2	= $db->sql_query ( $sql_2 );

					// Set the code up for it.
					$code		= ( $row[ 'tournament_status' ] == 1 ) ? '<input type="hidden" name="tournament" value="' . $row[ 'tournament_id' ] . '" /><input type="submit" name="submit" value="' . $lang[ 'rivals_tfcnt' ] . '">' : '';
					$code_2		= ( $db->sql_numrows ( $result_2 ) > 0 ) ? '(<a href="' . append_sid ( 'rivals.php?action=sponsors&tournament_id=' . $row[ 'tournament_id' ] ) . '">' . $lang[ 'rivals_gdhj' ] . '</a>)' : '';

					// Assign each tournament to the template
					$template->assign_block_vars ( 'block_tournaments', array (
						'U_SIGNUP' => $code,
						'U_SPONSORS' => $code_2,
						'S_I' => $i + 1,
						'S_ROWCOLOR' => ( $i % 2 ) ? 'row1' : 'row2',
						'L_DETAILS' => $lang[ 'rivals_vmd' ],
						'U_ACTION' => append_sid ( 'rivals.php?module=tournaments&sub_module=brackets&tournament_id=' . $row[ 'tournament_id' ] ),
						'U_ACTION2' => append_sid ( 'rivals.php?module=tournaments&tournament_id=' . $row[ 'tournament_id' ] ),
						'U_ACTION3' => append_sid ( 'rivals.php?module=tournaments&sub_module=signup&tournament_id=' . $row[ 'tournament_id' ] ),
						'S_TOURNAMENTNAME' => $row[ 'tournament_name' ] )
					);
				}
			}
			else
			{
				// No, show a message to the user.
				$template->assign_block_vars ( 'block_not', array (
					'L_NOTOURNAMENTS' => $lang[ 'rivals_67h' ] )
				);
			}

			// Assign the other variables to the template.
			$template->assign_vars ( array (
				'L_TOURNAMENTS' => $lang[ 'rivals_swiz' ] )
			);

			$template->set_filenames ( array (
				'body' => 'rivals/ts_mode4.tpl' )
			);
			$template->pparse ( 'body' );
		}
	}
}

?>
