<?php
##############################################################
# FILENAME  : mod_tournamentsbrackets.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Tournaments Brackets Class.
 * Shows the tournament brackets, it is sort of only a wrapper for the tournament class.
 */
class mod_tournamentsbrackets
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_tournamentsbrackets ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$tournament;
		global	$clan;

		// Count the number of clans.
		$clans		= explode ( '|', $tournament->data[ 'tournament_clans' ] );
		$num_clans	= count ( $clans );

		// Check if all the clans have signed up yet.
		if ( $num_clans != $tournament->data[ 'tournament_brackets' ] )
		{
			// Show who signed up.
			$message	= $lang[ 'atcansuy' ] . '<br /><ol>';
			foreach ( $clans AS $key => $value )
			{
				$message	.= '<li><a href="' . append_sid ( 'rivals.php?module=ladder&sub_module=ladderviewclan&clan_id=' . $value ) . '" class="forumlink">' . $clan->data ( 'clan_name', $value ) . '</li>';
			}

			$message	.= '</ol>';
			message_die ( GENERAL_MESSAGE, $message );
		}

		// Generate the tournament.
		$tournament->generate_tournament ( );

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'L_TOURNAMENTB' => $lang[ 'rivals_90901' ] )
		);

		$template->set_filenames ( array (
			'body' => 'rivals/ts_mode2.tpl' )
		);
		$template->pparse ( 'body' );
	}
}

?>
