<?php
##############################################################
# FILENAME  : mod_tournamentssignup.php
# COPYRIGHT : (c) 2006, Tyler N. King <aibotca@yahoo.ca>
# GPL v2.0 or later. See docs/COPYING.
##############################################################
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; 
# either version 2 of the License, or (at your option) 
# any later version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the 
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
# Boston, MA  02110-1301  USA
##############################################################
/**
 * ACP Tournaments Sign-Up Class.
 * Allows clans to sign-up for a tournament
 */
class mod_tournamentssignup
{
	/**
	 * Initilizes the class and displays the module.
	 */
	function mod_tournamentssignup ( )
	{
		// Include the globals needed to run this module.
		global	$db;
		global	$http_vars;
		global	$userdata;
		global	$lang;
		global	$template;
		global	$tournament;
		global	$clan;

		// Get the list of tournaments the clan is in.
		$stage	= explode ( '|', $clan->data[ 'clan_tournaments' ] );
		foreach ( $stage AS $tournaments )
		{
			// Check if they are in this tournament already.
			if ( $tournaments == $http_vars[ 'tournament_id' ] )
			{
				// They are. Let the user know.
				message_die ( GENERAL_MESSAGE, $lang[ 'rivals_uccu' ] );
			}
		}

		// Check if the clan has enough members to sign-up.
		if ( !empty ( $tournament->data[ 'tournament_rm' ] ) && count ( $stage ) <= $tournament->data[ 'tournament_rm' ] )
		{
			// The clan does not. Let the user know.
			message_die ( GENERAL_MESSAGE, sprintf ( $lang[ 'rivals_57dh' ], $tournament->data[ 'tournament_rm' ] ) );
		}

		// Get the list of clans in the tournament.
		$num_clans	= count ( explode ( '|', $tournament->data[ 'tournament_clans' ] ) );
		if ( $num_clans >= $tournament->data[ 'tournament_brackets' ] )
		{
			// They can not join, the tournament is full. Let the user know. 
			message_die ( GENERAL_MESSAGE, $lang[ 'rivals_msltt' ] );
		}
		else
		{
			// They can join. Is it private ?
			if ( $tournament->data[ 'tournament_state' ] == 2 )
			{
				// Yes, check if they entered the password.
				if ( !empty ( $http_vars[ 'password' ] ) && $http_vars[ 'password' ] == $tournament->data[ 'tournament_password' ] )
				{
					// Password correct. Add them to the tournament.
					$new_clans		= ( $tournament->data[ 'tournament_clans' ] == null ) ? $clan->data[ 'clan_id' ] : $tournament->data[ 'tournament_clans' ] . '|' . $clan->data[ 'clan_id' ];
					$new_tournaments	= ( $clan->data[ 'clan_tournaments' ] == null ) ? $http_vars[ 'tournament_id' ] : $clan->data[ 'clan_tournaments' ] . '|' . $http_vars[ 'tournament_id' ];

					$sql	= 'UPDATE ' . TOURNAMENTS_TABLE . ' SET tournament_clans = "' . $new_clans . '" WHERE tournament_id = ' . $http_vars[ 'tournament_id' ];
					$db->sql_query ( $sql );

					$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_tournaments = "' . $new_tournaments . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
					$db->sql_query ( $sql );
				}
				else
				{
					// Password incorrect or form not submitted. Let the user know.
					message_die ( GENERAL_MESSAGE, sprintf ( $lang[ 'rivals_waifg' ], append_sid ( 'rivals.php?module=tournaments&submodule=tournamentssignup' ), $http_vars[ 'tournament_id' ] ) );
				}
			}
			else
			{
				// Not private, add them to the tournament.
				$new_clans		= ( empty ( $tournament->data[ 'tournament_clans' ] ) ) ? $clan->data[ 'clan_id' ] : $tournament->data[ 'tournament_clans' ] . '|' . $clan->data[ 'clan_id' ];
				$new_tournaments	= ( $clan->data[ 'clan_tournaments' ] == null ) ? $http_vars[ 'tournament_id' ] : $clan->data[ 'clan_tournaments' ] . '|' . $http_vars[ 'tournament_id' ];

				$sql	= 'UPDATE ' . TOURNAMENTS_TABLE . ' SET tournament_clans = "' . $new_clans . '" WHERE tournament_id = ' . $http_vars[ 'tournament_id' ];
				$db->sql_query ( $sql );

				$sql	= 'UPDATE ' . CLANS_TABLE . ' SET clan_tournaments = "' . $new_tournaments . '" WHERE clan_id = ' . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );
			}
		}

		// Completed. Let the user know.
		message_die ( GENERAL_MESSAGE, $lang[ 'rivals_msssc' ] );
	}
}

?>
